<?php


// adminusers.php - List, modify, and add users from SIDB
// adminusers.php - author: SVI group University Utrecht and Nico Stuurman
  /***************************************************************************
  * This script displays a table with users in group of calling admin.       *
  * Functions to add or modify users and add auditors are integrated.        *
  * Deleting users is handled by script userdel.php (should be integrated    *
  *  here.                                                                   *
  *
  * Modified by Frank on 13-06-2000. Cleaned up code and fixed minor
  *  bugs.
  * Last modified by Nico on 11-8-00.  Disallowed admins to fool
  *  with other admins in the group
  * Modified 30-8-00 by Nico.  Added column with used space on disk
  *
  * Authors: SVI group University Utrecht and Nico Stuurman                  *
  * email: stuurman@rulbim.leidenuniv.nl                                     *
  * demo at: https://impi.leidenuniv.nl                                      *
  * Last modified 12/17/00                                                   *
  * Copyright (c) 2000 by Nico Stuurman                                      *
  * ------------------------------------------------------------------------ *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/                                                                                     

$userfields ="userid,login,real_name,pwd,groupid,status,email,homedir,outdir";

// main global vars
$title = "Admin Users";

// main include calls
require("include.php");

// register variables
$PHP_SELF = $HTTP_SERVER_VARS["PHP_SELF"];
$get_vars = "modify,userid,audit_add,user_add";
$post_vars = "userid,real_name,email,homedir,outdir,login,pwd,pwdcheck,status,user_group,modify,";
$post_vars .= "create,trust_array,audit_add,";

globalize_vars ($get_vars, "HTTP_GET_VARS");
globalize_vars ($post_vars, "HTTP_POST_VARS");


////
// check the form input data for validity
function check_input () {
   global $real_name, $login, $pwd, $user_group,$pwdcheck;

   if ($real_name and $login and $user_group)
      if ($pwd == $pwdcheck && strlen($pwd)<11)
         return true;
      else {
         echo "<h5>Passwords do not match or are too long! Please try again.</h5>"; 
         $pwd = "";
         $pwdcheck = "";
      }
   else
      echo "<h5>Some input is lacking!</h5>\n";
   return false;
}

////
// deletes an auditor
function auditdel ($userid, $groupid) {
   $query = "DELETE FROM auditors WHERE userid=$userid AND groupid=$groupid;";
   do_database_query ($query);
}

////
// can be called to create (type=create) or modify (type=modify) other users or oneselves (type=me) 
function modify ($type) {
   global $HTTP_POST_VARS, $G_GUEST, $G_USER, $G_ADMIN, $G_SUPER;
   global $S_STATUS, $S_USERID, $S_GROUPID, $people_dir;

   // creates variables from all values passed by http_post_vars, 
   // skips ones those are already set
   extract ($HTTP_POST_VARS, EXTR_PREFIX_SKIP, "post_vars");

   // check status of the victim to check that it is smaller than 
   //  the current users status
   if ($type == "modify")
      $original_status = get_user_info ($userid,"status");

   // check whether this is not illegitimate
   if (! ( ($S_STATUS==$G_SUPER) || ( ($S_STATUS==$G_ADMIN) && ($S_GROUPID==$user_group) 
         && ($S_STATUS > $original_status) ) || ($S_USERID == $userid) ) ) {
      echo "You are not allowed to do this. <br>";
      return false;
   }

   // check if everything is filled in
   if ($real_name and $login and $user_group):
      if ($pwd != $pwdcheck || strlen($pwd)>10):
         echo "Passwords do not match or are too long! <br> Please try again.";
      else:
         // if the user is known on this system, check if homedir exists:
         $user_exists = @posix_getpwnam (strtolower($login));
         if ($user_exists) {
            if ($homedir) {
               $temp = $people_dir."/".strtolower($login)."/".$homedir;
               $d = dir($people_dir . "/".strtolower($login)."/".$homedir); 
               if (!$d) {
                  $homedir = "";
                  echo "<br>The image directory $temp does not exist or cannot be read<br>";
                  echo "The image directory should be a subdirectory in: <b>$people_dir/$login</b><br>";   
                  echo "All other data submitted will be entered into the database<br><br>";
               }
            }
            if ($outdir) {
               $temp = $people_dir."/".strtolower($login)."/".$outdir;
               $d = dir($temp);
               if (!$d) {
                  $outdir = "";
                  echo "<br>The download directory $temp does not exist or cannot be read<br>";
                  echo "The download directory should be a subdirectory in: <b>$people_dir/$login</b><br>";
                  echo "Other data submitted will be entered into the database<br><br>";
               }
            } 
         }
         else {
            echo "User <b>$login</b> is not known on this filesystem.<br>\n";
            echo "Up and download will only be possible through a web browser.<br>\n";
            $homedir = "";
            $outdir = "";
         }
         // empty passwords lock the account to SQL databases
         if ($type=="create" && !$pwd)
            echo "Authentication will only be possible through PAM, not SQL.<br>";
         if ($pwd)
            $pwd=md5($pwd);
         // there seems to be a strange bug in Opera.  Workaround:
         if ($status=="on")
            $status=100;
         if (!($status)) $status = $G_USER; 
         if ($type=="modify"  && $userid) {
            $query = "UPDATE users SET login='$login', real_name='$real_name',  
                           groupid='$user_group', email='$email', homedir='$homedir', 
                           outdir='$outdir', status='$status'";
	    $query .= " WHERE userid='$userid';";
            //echo "$query<br>";
            if (do_database_query($query))
               echo "User <b>$real_name</b> modified.<br>\n";
            else
               echo "Could not modify user: <b>$real_name</b>.<br>\n";
            if ($pwd) {
               do_database_query("UPDATE users SET pwd='$pwd' WHERE userid='$userid'");
            }
         }
         elseif ($type =="create") {
            $query = "INSERT INTO users (login, pwd, groupid, real_name, status, active, email, homedir, outdir, login_defunct) ";
            $query .= "VALUES('$login', '$pwd', '$user_group', '$real_name', '$status', 't', '$email', '$homedir', '$outdir', '$login')"; 
            // echo "$query<br>";
            if (do_database_query($query))
               echo "User <b>$real_name</b> added.<br>\n";
            else
               echo "Failed to add user: <b>$real_name</b>.<br>\n";
         }
         else 
            echo "Strange error!< Please report to your system administrator<br>\n";
      endif;
   else:
        echo "Not all fields were entered; please try again!";
        //echo "$userid and $real_name and $login and $pwd and $user_group and $pwdcheck.<br>";
   endif;
}

////
// can be called to create (type=create) or modify (type=modify) other users or oneselves (type=me) 
function show_user_form ($type) {
   global $userfields, $S_STATUS, $G_GUEST, $G_USER, $G_ADMIN, $G_SUPER, $PHP_SELF;
   global $S_GROUPID, $S_USERID, $impose_folder, $infolder, $outfolder;
 
   // read in essential variables
   $fieldname = strtok ($userfields,",");
   while ($fieldname) {
      global ${$fieldname};
      //echo "$fieldname: ${$fieldname}<br>";
      $fieldname=strtok(","); 
   }

   if (!$groupid) $groupid = $S_GROUPID;

   // check whether this is not illegitimate
   if (! ( ($S_STATUS==$G_SUPER) || ( ($S_STATUS==$G_ADMIN) && ($S_GROUPID==$groupid)  
         && ($S_STATUS > $status) ) || ($S_USERID == $userid) ) ) {

      echo "groupid=$groupid<br>";

      echo "You are not allowed to do this. <br>";
      return false;
   }

   echo "<form method='post' action='$PHP_SELF'>\n";
   echo "<input type='hidden' name='userid' value='$userid'>\n";
   echo "<table>\n";

   echo "<tr><td>Full Name:</td>\n";
   if ($type=="create" || $type=="modify")
      echo "<td><input type='text' name='real_name' maxlength=50 size=25 value='$real_name'><sup style='color:red'>&nbsp(required)</sup></td></tr>\n";
   elseif ($type=="me")
      echo "<td>$real_name</td></tr>\n";

   echo "<tr><td>Email Address:</td><td><input type='text' name='email' maxlength=150 size=25 value='$email'></td></tr>\n";

   echo "<tr><td>Upload directory on the server:</td><td>\n";
   if ($impose_folder) {
      echo "$infolder</td></tr>\n";
      echo "<input type='hidden' name='homedir' value='$infolder'>\n";
   }
   else 
      echo "<input type='text' name='homedir' maxlength=150 size=25 value='$homedir'></td></tr>\n";
   
   echo "<tr><td>Download directory on the server:</td><td>\n";
   if ($impose_folder) {
      echo "$outfolder</td></tr>\n";
      echo "<input type='hidden' name='outdir' value='$outfolder'>\n";
   }
   else 
      echo "<input type='text' name='outdir' maxlength=150 size=25 value='$outdir'></td></tr>\n";
       

   if ($type == "create")
      echo "<tr><td>Login Name (max. 20 characters):</td><td><input type='text' name='login' maxlength=20 size=20 value='$login'><sup style='color:red'>&nbsp(required)</sup></td></tr>\n";
   else {
      echo "<tr><td>Login Name: </td><td>$login</td></tr>\n";
      echo "<input type='hidden' name='login' value='$login'>\n";
   }
   echo "<tr><td>Password (max. 10 characters):</td><td><input type='password' name='pwd' maxlength=10 size=10 value=''></td></tr>\n";
   echo "<tr><td>Password reType(max. 10 characters):</td><td><input type='password' name='pwdcheck' maxlength=10 size=10 value=''></td></tr>\n";



   if ($S_STATUS == $G_SUPER):
      echo "<tr>\n<td>Group:</td>\n<td><select name=\"user_group\">";
      $result = do_database_query("SELECT * FROM groups");
      $num = db_numrows($result);
      for ($i=0; $i<$num; $i++)
      {
         $grouprow = db_fetch_array($result, $i);
         $selected = "";
         if ($groupid == $grouprow["groupid"]):
             $selected = " selected";
         endif;
         echo "<option value=\"" . $grouprow["groupid"] . "\"" . $selected . ">" . $grouprow["groupname"] ."\n";
      }
      echo "</select></td>\n</tr>";
   else:
      echo "<input type=\"hidden\" name=\"user_group\" value=\"" . $S_GROUPID . "\">";
   endif;

   // Checkboxes to give users a status.
   // set default status_choice to $G_USER
   if ( !($status) )
      $status = $G_USER;
   if ( ($type=="modify" || $type=="create") && $S_STATUS >= $G_ADMIN) { 
      if ($S_STATUS == $G_SUPER) {
         echo "<tr><td>Group-Admin:</td>\n";
         if ($status >= $G_ADMIN)
            $checked = "checked";
         else
            $checked = "";
         echo "<td><input type='radio' name='status' value='$G_ADMIN' $checked></td></tr>\n";
      }
      if ($status == $G_USER )
        $checked = "checked";
      else
         $checked = "";
      echo "<tr><td>User:</td>\n<td><input type='radio' name='status' value '$G_USER' $checked></td></tr>\n";

      if ($status == $G_GUEST)
         $checked = " checked";
      else
         $checked = "";
      echo "<tr><td>Guest:</td>\n";
      echo "<td><input type='radio' name='status' value='$G_GUEST' $checked></td></tr>\n";
   }
    
   if ($type == "modify")
      echo "<tr><td></td><td><input type='submit' name='modify' value='Modify User'></td></tr>\n";
   elseif ($type == "create")
      echo "<tr><td></td><td><input type='submit' name='create' value='Create User'></td></tr>\n";
   echo"</table>\n";
   echo "</form>\n";
}


/****************************** main script ***********************************/

// extend title if user is an admin
if ($S_STATUS == $G_ADMIN):
   $title .= " in ".groupname($S_GROUPID);
endif;

// Only a groupadmin and sysadmin are allowed to view this page
Auth::allowonly($G_ADMIN);

printheader();

if ($audit_add == "true") {
   echo "<TABLE>\n";
   echo "<FORM enctype='multipart/form-data' METHOD='post' ACTION='$PHP_SELF'>\n";
   echo "<TR><TD>";
   box_users (0, "Select the new guest:", "WHERE groupid<>$S_GROUPID AND userid NOT IN (SELECT userid from auditors WHERE groupid=$S_GROUPID)");
   echo "<TR><TD>\n";
   echo "<INPUT TYPE='submit' NAME='audit_add' VALUE='Add guest'></TD>\n";
   echo "<TD><INPUT TYPE='submit' NAME='audit_add' VALUE='Cancel'></TD></TR>\n"; 
   echo "</FORM>\n";
   echo "</TABLE>\n";
}

elseif ($user_add =="true") {
   show_user_form ("create");
}

elseif ( ($create == "Create User") && exist_user($login) ) { 
   echo "<h5>A user with that login name already exists. Please try another one.</h5>\n";
   $login = "";
   show_user_form ("create");
}

elseif ( ($create == "Create User") && !(check_input() )) { 
   show_user_form ("create");
}   

elseif ( ($modify == "Modify User") && !(check_input() )) { 
   show_user_form ("modify");
}   

elseif ($modify == "true") {
   // pull existing data from database
   $query = "SELECT $userfields FROM users WHERE userid=$userid;";
   $result = do_database_query($query);
   $row = db_fetch_array($result, 0);
   // and translate into global variables
   $fieldname = strtok ($userfields,",");
   while ($fieldname) {
      ${$fieldname}= $row["$fieldname"];
      // echo "$fieldname: ${$fieldname}<br>";
      $fieldname=strtok(","); 
   }
   show_user_form ("modify");
}

else {
   if ($modify == "Modify User") {
      modify ("modify");
   }
   if ($create == "Create User") {
      modify ("create");
   }
   elseif ($audit_add == 'Add guest') {
      $auditor = last_array_value ($trust_array);
      // first check wether user is indeed outside of group:
      if ($auditor) {
         $query = "SELECT groupid FROM users WHERE userid='$auditor';";
         $result = do_database_query ($query);
         $r_array = db_fetch_array ($result,0);
         $groupid = $r_array["groupid"];
      
         if ($S_GROUPID <> $groupid) {
            $query = "INSERT INTO auditors VALUES ($auditor, $S_GROUPID);";
            do_database_query ($query);
         }
      }
   }
   elseif ($HTTP_POST_VARS) {
      //determine wether or not the remove-command is given and act on it
      while((list($key, $val) = each($HTTP_POST_VARS))) {
         if (substr($key, 0, 3) == "del") {
            $delarray = explode("_", $key);
            auditdel($delarray[1], $S_GROUPID);
            $del = true;
         }
      }
   }     
 
   echo "<form name='form' method='post' action='$PHP_SELF'>\n";

   // set database query
   $db_query = "SELECT * FROM users";

   // if user is not sysadmin then only list users of admin's group
   if ($S_GROUPID != 0):
      $db_query .= " WHERE groupid='$S_GROUPID'";
   endif;


   // extend query to order output list on login name
   $db_query .= " ORDER BY login";

   // print header of table which will list users
   echo "<table border='1'><caption><h5>Users</h5></caption>\n";
   echo "<tr>\n";
   echo "<th>Login</th>\n";
   echo "<th>Real Name</th>\n";
   echo "<th>Used space</th>\n";
   echo "<th>Group</th>\n";
   echo "<th>Admin</th>\n";
   echo "<th>User</th>\n";
   echo "<th>Guest</th>\n";
   echo "<th>Active</th>\n";
   echo "<th colspan=\"2\">Action</th>\n";
   echo "</tr>\n";

   // get result and number of rows in result
   $db_result = do_database_query($db_query);
   $db_rows = db_numrows($db_result);          

   // for each row, print result in table cells
   for ($i=0; $i<$db_rows; $i++) {
      // set database result per row
      $db_row_result = db_fetch_array($db_result, $i);
      $status = $db_row_result["status"];

      // display admin dot if status of user is admin
      if ($status  == $G_ADMIN) {
         $stat[0] = "<li>&nbsp;";
         $stat[1] = "&nbsp;";
         $stat[2] = "&nbsp;";
      }
      elseif ($status == $G_USER) {
         $stat[0] = "&nbsp;";
         $stat[1] = "<li>&nbsp;";
         $stat[2] = "&nbsp;";
      }   
      elseif ($status == $G_GUEST) {
         $stat[0] = "&nbsp;";
         $stat[1] = "&nbsp;";
         $stat[2] = "<li>&nbsp;";
      }   
      else {
         $stat[0] = "&nbsp;";
         $stat[1] = "&nbsp;";
         $stat[2] = "&nbsp;";
      }   
      $active_result = $db_row_result["active"];
      if ($active_result == "t")
         $active_text = "<li>&nbsp";
      else
         $active_text = "&nbsp";

      // calculate the amount of space used on disk.  
      if ($space_used = get_user_space ($db_row_result["userid"]))
         $space_used = nice_bytes ($space_used);
      else
         $space_used = "&nbsp;";
   
      // print table output per row
      echo "<tr>\n";
      echo "<td><b><a href=\"mailto:".$db_row_result["email"]."\">".$db_row_result["login"]."</a></b></td>\n";
      echo "<td>".$db_row_result["real_name"]."</td>\n";
      echo "<td>".$space_used."</td>\n";
      echo "<td>".groupname($db_row_result["groupid"])."</td>\n";
      echo "<td align=\"center\">$stat[0]</td>\n";
      echo "<td align=\"center\">$stat[1]</td>\n";
      echo "<td align=\"center\">$stat[2]</td>\n";
      echo "<td align=\"center\">$active_text</td>\n";

      // don't delete/modify yourself, and, except for sysadmin, 
      // do not let admins fool around with other admins in group
      $userid = $db_row_result["userid"];
      if ( ($S_USERID <> $userid) &&  ( ($db_row_result["status"] < $G_ADMIN) || ($S_STATUS == $G_SUPER)) ) {
         echo "<td><a href=\"$PHP_SELF?modify=true&userid=".$userid."\">Modify</a></td>\n";
         echo "<td><a href=\"userdel.php?id=".$userid."\">Delete</a></td>\n";
      }
      else
         echo "<td>none</td><td>none</td>";
     
      echo "</tr>\n";
   }

   // print end of table
   echo "</table>";

   // print link to perform adjustements made
   echo "<p><a href='$PHP_SELF?user_add=true'>Add a User</a></p><br>";

   // if there are any, show a list with auditors
   if ($S_USERID <> $G_SUPER) {
      $query = "SELECT * FROM USERS WHERE userid IN (SELECT userid FROM auditors WHERE groupid=$S_GROUPID) 
             ORDER BY login";

      // get result and number of rows in result
      $db_result = do_database_query($query);
      $db_rows = db_numrows($db_result);          
      if ($db_rows > 0) {
         // print header of table which will list users
         echo "<table border='1'><caption><h5>Auditors (outside users who may see your group's images)</h5></caption>\n";
         echo "<tr>\n";
         echo "<th>Login</th>\n";
         echo "<th>Real Name</th>\n";
         echo "<th>Group</th>\n";
         echo "<th>Action</th>\n";
         echo "</tr>\n";


         // for each row, print result in table cells
         for ($i=0; $i<$db_rows; $i++) {
            // set database result per row
            $db_row_result = db_fetch_array($db_result, $i);

            // print table output per row
            echo "<tr>\n";
            echo "<td><b><a href=\"mailto:".$db_row_result["email"]."\">".$db_row_result["login"]."</a></b></td>\n";
            echo "<td>".$db_row_result["real_name"]."</td>\n";
            echo "<td>".groupname($db_row_result["groupid"])."</td>\n";
            $delstring = "<input type=\"submit\" name=\"del_" . $db_row_result["userid"] . "\" value=\"Remove\" ";
            $delstring .= "Onclick=\"if(confirm('Are you sure this persons ability to see images from this group ";
            $delstring .= "should be revoked?')){return true;}return false;\">";
            echo "<td align=\"center\">$delstring</td></tr>\n";
            echo "</tr>\n";
         }
         echo "</table>\n";
      }
      // and a link to add so-called auditors
      echo "<p><a href=\"$PHP_SELF?audit_add=true\">Give an outsider the right to see images from this group</a></p>\n";

      echo "</form>\n";
   }
}
printfooter();

?>

