<?php

// config_inc.php - Initialization of variables.
// config_inc.php = author: Nico Stuurman <nicost@sourceforge.net>
  /***************************************************************************
  * This file is loaded by every script so that                              *
  * the same overall information available.                                  *
  *                                                                          *
  * Below are the global variables for the system.                           *
  * EDIT THESE LINES TO MATCH YOUR SYSTEM SET-UP.                            *
  *                                                                          *
  ****************************************************************************
  *                                                                          *
  * Authors: SVI group University Utrecht and Nico Stuurman                  *
  * email:nicos@itsa.ucsf.edu                                                *
  * demo at: https://impi.leidenuniv.nl                                      *
  * Copyright (c) 2001 by Nico Stuurman                                      *
  * ------------------------------------------------------------------------ *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the Licens, or (at your   *
  *  option) any later version.                                              *
  \**************************************************************************/                                                                                     

// version number
$version = 0.41;

/*
 * Create the standard class to hold config information.
 */
$sidb = new stdClass();
#$sidb->debug = true;

/*** The following two directories should not be web-accessible. ***/
/*** Consider moving them outof your web-tree ***/

// directory where archive will store the uploaded files.
$archive_dir = "/home/wwwrun/archive";
// dir for thumbnails
$thumbnail_dir = "/home/wwwrun/thumbnails";


// directory where include files are (this one included!)
$include_dir = "includes";

/*** PostgresQL database settings ***/
// for security, fill in your own and make them work!
$db_host = "localhost";
$db_port = "5432";
$db_name = "sidb";
$db_user = "postgres";
$db_pass = "foobar";


/*
 * Create a list of users for we want to receive an email when they have
 * uploaded images. This can be handy for the administrator or maybe an
 * support departement who have created specific users for uploading
 * images with a special purpose. Of course you have to be sure the users
 * in this list exists. If they don't, of course that is no problem at all,
 * but it'll more usefull to have correct userLOGIN list:-)
 */
$emailNotifyList = "all";
$emailExcludeList = "sysadmin";
/*
 * Then we want the email address to send the upload notifications to.
 */
$emailNotifyAddress = "jose@svi.nl";
$emailSenderAddress = "sidb@svi.nl";
/*
 * The above is used in the class file class-email.php.
 */

// Are you using huscript (Huygens Scripting Software)? (http://www.svi.nl).  
$IMAGE_TOOLS = false;

// give location of huscript binaries.
// if you don't want to use them, just leave this empty
$image_tool = false;

// location of Imagemagick convert.  When installed, get this by typing 'which convert' in your shell
$convert_path = "/usr/bin/convert";

// maximum filesize handled by convert. Do not exceed 25-50% of your systems RAM
$max_size_for_convert = 33554432;  

// Location of iptcutil, needed to extract comments from image files
$iptcutil_path = "/usr/bin/iptcutil";

// application that will generate an mpeg movie from a series of TIFF files
// presently, we use convert, so copy the value for $convert_path here
$movie_tool = "/usr/bin/convert";

// maximum file size handled by movie generator.
// Currently, making movies taxes the system heavily.
// Keep this number below 10% of your available RAM
$max_size_for_movie = 12000000;  

// Do you want sent the applet ImageJ to your users?
// if so, you will need to put a patched version of ij.jar in your sidb folder
$use_imagej = 0;


// give some reasonable borders for thumbnail sizes (in pixels)
$max_thumb_size = 512;
$default_thumb_size = 300;
$min_thumb_size = 100;


// Images can be uploaded through html, but also through mounted drives
// Sidb allows acces to directories composed as follows: 
// $people_dir/$user_name/$(in/out)folder
// for this to work, the sidb user name must be identical to the username 
// on the host system

// root for user dirs on host system (usually /usr/people)
$people_dir = "/home";

// You can let users choose their own $(in/out)folder names, 
// or set them here system wide
// If you do 'impose' the directory names, make sure they exist, 
// and that your users know how to work with them
$impose_folder = true;
// Names of folders in users homedirs
$infolder = "tosidb";
$outfolder = "fromsidb";

// Files can be 'downloaded' into the directory $outfolder.   
// Set a limit on the size of folder $outfolder 
$max_folder_size = 1073741824;   // 1 gigabyte

// To show gallerys (search.php), thumbnails have to be generated on the fly.  
// To save resources, set a limit for the number of images per gallery
$max_in_gallery = 40;

// Use the ability to make movies from rotating 3-D objects
// Since this uses lots of CPU and RAM, you better only activate 
// it on REAL COOL servers
$make_rotating_movie = false;

// Your servers root (the stuff after http://)
// install.php will set this automatically each tine it is run
$sidb_root = "localhost/sidb";

/* These settings are not controlled by global.php and are for experts only */
$experimental = false;

//location of compress utility (use gzip when possible)
$bzip2="/usr/bin/gzip";

// delay before we'll compress (default: no compressing)
$compress_delay=0;

// authenticate with session or HTTP pop-ups
$use_sessions=true;

// Do we have a secure server on board?
$secure_server=true;

// Was check_pwd installed?
$pam_prg=false;

/*************** DO NOT EDIT BELOW THIS LINE  ****************/

// we need these files for every script
require("$include_dir/init_inc.php");

// we need next inc file for user and group functions.
require("$include_dir/functions_inc.php");


opendatabase();

require("$include_dir/class-auth.php");


/**Below this line additions might have been made by the install.php script ***/
?>
