<?php

  /**************************************************************************\
  * help.php    Provides contextual help.  Needs updating and better UI.     *
  ***************************************************************************
  *                                                                          *
  * Authors: SVI group University Utrecht and Nico Stuurman                  *
  * email: stuurman@rulbim.leidenuniv.nl                                     *
  * demo at: https://impi.leidenuniv.nl                                      *
  * Copyright (c) 2000, 2001 by Nico Stuurman                                *
  * ------------------------------------------------------------------------ *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/ 


$title = "SIDB Help";
include ("include.php");
printheader();

?>

<a name="start"><H2>Overview</H2></a>
<p>SIDB (Scientific Image DataBase) is a database system for groups working with 2-D and 3-D images.  It lets you store and
retrieve images, and lets you decide who else can view the images.  SIDB not only stores the
original file unchanged, but also data describing the image (henceforth called image meta-data), like
a description and keywords. Templates make it easy and painless to enter these image meta-data.
</p>
<HR>
<A NAME="login"><H2>Topics</H2></a>
<P>

How to <A HREF="#upload"><B>Upload your image</B></a><BR>
How to <A HREF ="#search"><B>Search for your image</B></a><BR>
How to <A HREF="#show"><B>View and download your image</B></A><BR><BR>

<?PHP  
if ($S_STATUS >= $G_ADMIN ): 
?> 
<A HREF="#adminusers"><B>UserAdmin</B></A><BR>

How to <A HREF="#useradd"><B>Add a User</B></A><BR>
How to <A HREF="#modifyuser"><B>Modify a user</B></A><BR> 
How to <A HREF="#userdel"><B>Delete a User</B></A><BR><BR>

<?PHP 
endif; 
if ($S_STATUS == $G_SUPER):
?> 

<A HREF="#admingroups"><B>GroupAdmin</B></A><BR>

How to <A HREF="#addgroup"><B>Add a Group</B></A><BR>
How to <A HREF="#groupdel"><B>Delete a Group</B></A><BR><BR>

<?PHP
endif;
?> 

<A HREF="#mypictures"><B>My Pictures</B></A><BR><BR>
<A HREF="#profile"><B>Profile</B></A><BR>

How to <A HREF="#changepwd"><B>Change password</B></A><BR>
How to <A HREF="#template"><B>Administer your templates</B></A><BR>
How to <A HREF="#modifytemplate"><B>Modify your templates</B></A><BR>
How to <A HREF="#deltemplate"><B>Delete your templates</B></A><BR><BR>


How to <A HREF="#index"><B>Logout</B></A><BR>
</P>

<hr>
<a NAME="show"><h2>View and download your image</h2></a>
<p>
First, use the <A HREF="#search">search</A> function (or the 'My Pictures' button) to find your image.
Then, click on the small thumbnail on the left side of the table.
This will show you an enlarged version of the thumbnail and all the information about the 
image that had been stored in the database. In many cases the thumbnail is a hyperlink.  For 3-D and ICS/IDS files, clicking on this link should bring up an MPEG movie file containing all the layers of the image.  Whether or not you can see this movie depends on your browser.  I had best results using <a href="http://www.quicktime.com">Quicktime</a>, version 5 and up. For '2-D' and 'other' images, what happens will depend on the mime-type associated with the image.  The mime-type was automatically set during upload of the file, the image's owner may, however, set the mime-type automatically by choosing 'modify image metadata'.  How your browser interprets the mime-type depends on your browsers and computers settings.  Clicking on an 'image/tiff' link is a sure way to make Internet Explorere very confused...</p>

<p>You can: 
<UL>
<LI><I>download</I> the file to your local disk by clicking 
the '<b>Download 2-D, 3-D, or ICS</B> links.  Select the directory where you want to save your image
in the ensuing pop-up window. 
<br /><b><i>Note:</i></b>If you want to download an ICS-file you have to download both ICS and IDS files (this applies for ICS1 format, as ICS2 is just one ICS file). 
<br /><b><i>Internet Explorer users</i></b>: IE does not adhere to the WWW standards.  It will try to show you the file instead of download it.  This is fine for JPG and GIF files, but can be a big problem for other file types.  Therefore, click on the link with the right mouse button and choose 'save target as'.</LI>
<li><i>Export as ICS file to your download directory</i>: This item is only shown with 3-D and ICS files.  The Microscope settings, Voxel specifications and Channel-specific metadata as known to the database will be written to the ICS/IDS file pair.  This is handy when you want to work with yoru image data in software packages that understand ICS/IDS files (like <a href="http://www.svi.nl">huygens</a>).
<li><i><a name="imagemod">Modify Image metadata</a></i>: If you made mistakes, or forgot something, here is your chance.  
<br />When you change the thumbnail size (or channel color), the new thumbnail will appear only after clicking 'remake Thumbnail', or 'original'.
<br />The various fields are described <a href="#upload">below</a>.  The only addition is the mime-type of the image.  Only change this when you know what you are doing!</li>
<LI><I>Remake Thumbnail</I>: Will remake the thumbnail based on the current settings</LI>
<LI><I>Import New/novel thumbnail</I>: This function can be used to assign any arbitrary image as a thumbnail (view onto your file). A selection box will appear in which you can select the file to be used as a thumbnail for the original data (which will not be affected by this operation). When performing this action, the type of your image will automatically become 'other'.</LI>
<LI><I>Show Printable</I>: Yields the same page in a format pretty for printing.  For best results, adjust the printer set-up of your browser to suit your taste.  Very handy for your labjournal, notbook, etc..</LI>
<LI><I>Rotate</I>: Will generate a new thumbnail with the indicated rotation with respect to the original file. The original file (not the current thumbnail) is used as input.  Therefore, rotating twice is not very usefull.</LI>
<LI><I>Original</I>: Will remake the thumbnail based on the current settings (same function as 'Remake Thumbnail').</LI>       
</UL>
</p>





<hr>
<A NAME="search"><H2>Search</H2></a>
<P>

With the search function you can find all your own images as well as those from others visible to you.
The search results will be placed in a <b>table</b> from where you can view them (and delete your own images if you please). 
Alternativelly, you can select to produce just a <b>list</b> of results, to easilly make multiple selections and operate in groups of images.</p>
<p>Click on <B>My pictures</B> to see all of your own images.</p>
<p>You can search on the following fields:
<ul>
<li>Name of the image: multiple tokens are possible, separated by spaces. Use wildcards: * for any chain between some strings, ? for a single character. Examples: img*56, L?1.
<b>Some elements</b> of <a href="http://www.regular-expressions.info/">regular expresions</a> (<b>RE</b>) are also possible: use [1-5] to find any number ranging 1 to 5 in a given position.
 A vertical bar | gives alternatives inside a logical unit delimited by (parentheses): use ([ab]|[f-g]) to find the characters <i>a, b, f, g</i> OR <i>h</i> 
in a given position. L[1-5]? will return all labels from L10 to L59, L[af]? will match Lab and Lfb, but not Lcb. [^a-g] will match any character <b>except</b> letters from <i>a</i> to <i>g</i>. 
An exclamation mark ! before a string negates the RE item: !vol is anything not including <i>vol</i>.
Notice: the asterisk and the question mark are wildcards, and the dot is itself, and will not work as in standard regular expressions.
You can choose between searching all the (space separated) items that you type (AND search), or just any of them (OR search). The order of the strings is not relevant. 
If you want to specify a given order, use the asterisk * to link strings, like in "first*second".</LI>
<li>Image ID: multiple ID patterns are possible, ANY of them will be searched in the file ID. 
You can use comparison operators, like &gt;500, &lt;=500, !=500 or &lt;&gt;500. Typing =500 is equivalent to type just 500. Ranges are also possible, like in 500-600 or 500- (which is equivalent to &gt;=500). Upper limited ranges must be specified as in &lt;=500, because -500 is negative 500.
Wildcards and some RE are also avaliable. Thus, [1-3]? will return all images with ID from 10 to 39, but not 100 or 300.
 For that, you could search e.g. for [13]??, that will return all 100-199 and 300-399, but not any 200-299. 
Again, ^ negates the characters inside [brackets] for a given position, and ! negates the complete RE item. </li>
<li>Name of the owner</LI>
<li>Persons who have been specifically allowed to see the image</li>
<li>Any term in the description field. Elements of RE are possible as explained above for the name and the ID.</LI>
<li>Date of upload</LI>
<li>Keywords and projects</li>
<li>Image and microscopy parameters. As with the image ID, numerical comparison, ranges, wildcards and partial RE are possible.
<li>For channel parameters only wildcards and RE are avaliable, not numerical comparisons or ranges. 
You can specify if the channel parameter query applies to a specific channel, or to any by leaving the channel box empty. The first channel is numbered 1. 
</ul>
</p>
<p>
When entering multiple fields, all of them have to be present (i.e. a logical 'AND' is applied).</P><p>The drop-down menus in the search form only show items/persons belonging to images you may see.  Selecting any single one of these should therefore yield a result (of course, this is not true when you make combinations).  Moreover, this also alllows you to make 'secret keywords'.  Other users will not see them as long as they belong uniquely to images they may not see.</p>
<P>It is also possible to specify the number of results per page in the <b>table</b> mode. 
If you don't fill in a number you will see 10 images a time.
</P>

<P>
If you don't fill in anything you will find all your own images in the database, those images 
entered by other members of your group and that can be seen by group members only, as well as 
public images from users outside of your group.
Click on the <B>Search Database</B>-button to see the results of your search.</p>

<p>The results in the <b>list</b> mode show the results list with some extra information: the image ID, the owner username, and the file size. A plus sign preceeds a file owned by you, a minus sign preceeds file which you do not have permission to modify.

<p>The resulting table in the <b>table</b> mode contains a
thumbnail, imagename, assigned keywords, the name of the owner of the images (to whom you can send email by clicking on 
his/her name) and the date of upload.
Only images which are public to other users and your own images will be visible.
</p>
<p>You can do the following:
<UL>
<LI>Scroll between the results with the previous and next buttons. </LI>
<LI>Send email to the owner of the file by clicking on his/her name. </LI> 
<LI>Click on the thumbnail, you'll see a more detailed <A HREF="#show">view</A> of the file. It is also possible to download the file.</LI>
<LI>Delete a file by clicking on the delete file button, but only when you are the owner of the image.</LI>
<li>Make a gallery with the filename and thumbnails of the images. When checking the box 'printable' the blue outline will not appear, making it nicer to rpint the resulting gallery.  Note that some browsers might cut off the thumbnails somewhere halfway when printing, play around with the pixel size, number of columns and page orientation to get a nice result.  You can choose to make the gallery from all images found, or only the ones you selected.</li>
<li>Save the files.  They will be placed in your download directory on the server (check under <a href="changepwd.php">settings</a>)</li>
</ul>
</p>
<p> 
If you want to search other fields or with changed values you can do so by altering the fields and click on the <B>Search
Database</B>-button.
</p>


<HR>
<A NAME="upload"><H2>Upload</H2></A>
<P>
<B>Select filetype and template</B><Br>
Here you tell the system what kind of file to expect and you can pick a template to facilitate entering 
image meta-data.
<UL>
<LI>Filetype: 
  <ul>
  <li><b>2-D.</b> All 'normal' images (TIF, GIF, JPG, photoshop, etc.).  Athumbnail will be generated by the (Open Source) application Imagemagick.  File formats supported by Imagemagick can befound <a href="convert_info.php">here</a>.</li>
  <li><b>Multipage.</b> Files that contain 'series' of images, like digitized video sequences.  A thumbnail will be generated by Imagemagick, and a MPEG movie with the complete sequence can also be made. </li>
  <li><b>3-D.</b> Images produced by a confocal microscope, such as Biorad PIC files and Leica TIFFs. A projection of the image stack will be produced by an application called <i>huygens</i>.  A list with file formats supported by huygens can be found at <a href="http://www.svi.nl">http://www.svi.nl</a>. </li>
  <li><b>ICS.</b> This is the native file format of <i>huygens</i>.  It consists of two files, the *.ics header file, and the *.ids file containing the data. The *.ids file contains the actual image data and can also be stored in the gzipped format which has the extension .ids.gz. SIDB will store .ids files gzipped as .ids.gz files to save disk space and bandwidth.</li>
  <li><b>ICS2</b> The new ICS2 file format is just one single ICS file with the header and the data together, and should be uploaded as any other 3-D image.
  <li><b>Other.</b> Each and every other file can be uploaded here (and that includes your Word and Powerpoint files).  You simply have to provide a thumbnail image yourself.</li>
  </ul>
</LI>

<LI>Template: Select a template from the dropdown-menu. To create a new template, 
click on the 'templates' button on the left. If you don't want to use any template select <B>No template</B>.</LI>
<LI>File transfer method.  When you have an account on the server itself and entered a valid
directory in your <a href="#changepwd">personal settings</a> you may opt to have the database check 
that directory for images.  If you do not have such a directory you will not see the option and you
will automatically upload your image through the internet</LI> 
</UL>
When you made your choice click the <B>Next</B>-button to continue.
</p>

<p><b>Upload your ??? file here</b><br />
This screen looks different, depending on the filetype you are uploading.  The '2-D'
and 'other' screens are subsets of the screens for '3-D' and 'ICS' filetypes.</P>
<ul><li><i>'File location'</i>: 
<ul><li>HTML upload: You can fill in the directory of the file 
you want to upload or click on <B>Browse</B> to find it on your
computer. If you want to upload an ICS file you have to select two
locations: one for the ICS file and another for the IDS file. Most
of the time you can find these two files in the same directory.</LI>
<li>'Local' upload.  You will be presented with a list of files in your image directory, located at this same server. (You must be a local user, ask your system administrator).
Choose the one you would like to add to the database.  When adding an ics/ids file couple you 
can pick either one of the two files. Important: permission for 'others' to read your files must be set on. Otherwise the SIDB cannot access them. Files will be moved (deleted from your image directory).  </li></ul>

<li><i>'Description'</I>: Fill in everything important about the image. You have lots of space (about 8 kbytes) 
to do so.  In the not too distant future, you will thank yourself for taking the time 
to write down what is in your image, how you made it, etc..<br>
A very useful trick is to enter hyperlinks to other (related) images.  If you, for instance,  applied some filters and did some other tricks to an image and save the rsulting file into the database, it is very useful to go to the old, unmanipulated image with a single click.  To make such a hyperlink you only have to know the 'database ID' of the image you want to link to.  In the description field, enter the following (for instance by copy and paste):
<pre>
&lt;a href=show.php?id=###&gt;original image&lt;/a&gt;
</pre>
Replace '###' with the database ID of the image you want to link to, and 'original image' with whatever text you want to be displayed as the hyperlink. 
</li> 
<LI><I>'Raw data?'</I>: When these data have been freshly captured on your camera/microscope/scanner, or whatever,
and not been processed in any way, these are raw data and you should check this box.  </LI>

<li><i>'Me'</i>: If nobody but you should see this image, then select this checkbox.</LI>
<li><i>'My group'</i>: You can restrict access to the image to members of your group only by checking
 this box.  If you check both 'private' and 'group', the image will be private and invisible to anyone 
 else</li>
<li><i>'Everyone'</i>:Indeed, the rest of the world. Realize that having search results including your images might even be annoying to others!</li>
<li><i>'and also'</i>:Here, you may select that specific person who is not in your group, but may see your image.</li> 

<li><i>'Keywords'</i>: Select the <a href=#keyword>keywords</a> appropriate to your image.  Enter some!  They make it much 
easier to find your image later on.  Multiple selections are possible (depending on your browser you might have to Ctr-click, shift-click, or just click). If the right keyword is not there, add it by clicking 'keywords' on the left (regretfully, you will loose information entered so far). </LI>
<li><i>'Project'</i>: If you defined a <a href=#project>project</a> before, you can now assign the image to a project. Using projects you can organize your images in a folder-like structure. </li>
<li><i>'Thumbnail size'</i>: Sets the size (in pixels) for the thumbnail to be used to 'view' your image file. The minimum value is <?php global $min_thumb_size; echo $min_thumb_size ?>, the maximum <?php echo $max_thumb_size ?>.  When you do not enter anything the thumbnail will be a maximum of <?php echo $default_thumb_size ?> pixels in x or y direction.</li>
</ul>

<ul><b>3-D/ICS filetype only:</b>
<li><i>'Geometry'</i>: Size of each sample (voxel, pixel) in nm or second.</LI>
<li><i>'Optical parameters'</i>:<ul>
<li><i>'Sensortype</i>: Type of microscope, likely to be confocal or Wide-field.</LI>
<LI><I>'Numerical aperture</I>: <i>na</I> of the lens/objective used.  Look it up.</LI>
</LI></UL>
<LI><I>Refractive Indexes</I>:<UL>
<LI><I>Lens</I>: Refractive index of medium between objective and coverslip.  Likely to be water (1.33) 
or oil (1.53)</LI>
<LI><I>Medium</I>: Refractive index of medium embedding the sample. Probably similar to that of water (1.33)
or oil (1.53) </LI>
</LI></UL>
<LI><I>Channel specific information</I>: Channels are numbered from 1 up.  Only after you entered something into a channel it will become a valid channel.   To change the number of channels, select the appropriate number and press the 'Change' button.   Regretfully, a bug exists such that the file location is lost when pressing the 'Change' button.  Therefore, enter the file location last.
<ul>
<li><i>Ex, Em (nm)</i>: Excitation and Emission wavelengths respectively, in nanometers.</li>
<li><i>Photons</i>: Number of photons in the excitation process.  Usually 1, except in multi-photon applications.</li>
<li><i>Pinhole</i>: Size of the back-projected pinhole in nanometers.  Check with your microscope vendor if you don't know.  More information can be found in the manual to the Huygens software, or at the <a href="http://www.imaris.com">Bitplane site</a>.
<li><i>Color</i>: Color for this channel in the thumbnail.  Regretfully, this information is not used by the Huygens software when making the thumbnail (it will default to green, red, blue) although this feature will be introduced in the near future.</li>
</ul>  
</ul>
<P>
<B><I>Note:</I></B> 
<UL><LI>You do not have to enter all the meta-data. <B><I>Only the file
location is essential</I></B>. 
Please note that the more information you provide now, the better you will be able to find your file later on,
and the more valuable the image will proof to be.</LI>
<LI>When the given file location is not valid, the information you enterd will be kept and you will be 
given another chance to enter the file's location.</LI>
<LI><A NAME ="space"></A> When your file is larger than the size indicated on screen, 
your upload will fail after a very long time.</LI>
<LI><A NAME ="invalid"> </A>Make sure that the selected location of the file exists. </LI> 
<a name=html_upload_error></a><li>On some systems, HTML file upload of files of about 1 MB and up fails.  The system returns with the first 'upload' screen.  Try saving the file into your 'Upload directory' on the server and using 'Move file from your image directory' instead of 'HTMl file Upload'.</li>
</UL>
</P>

<P>
After you have filled in the file location, press the button
<B>Upload File</B> and your image will be stored. 
<BR>
You will be shown a screen with a (thumbnail) view on your file and a summary of the information you entered.
</P>
<?PHP  
if ($S_STATUS >= $G_ADMIN): 
?> 
<HR>
<A NAME="adminusers"><H2>Users</H2></A>  
<P>
Here you can see the users already defined, their real name, the group to which they belong 
and whether they have administrator rights for that group. Also, you can 
modify or delete (i.e remove) users.</p>
<p>
How to <A HREF="#useradd">Add a user</A>
<BR>
How to <A HREF="#modifyuser">modify a user</A>
<BR> 
How to <A HREF="#userdel">delete a user</A>
<br>How to <a href="#auditor">make outside users an auditor in your group</a>
</P>

<A NAME="useradd"><H3>Add a User</H3></A>
<P>
To add a user click on <B>Add a user</B>. Now you see a form to fill in the essential data:
</P>
<UL>
<LI><I>'Full name'</I>: Fill in the full name of the user you want to add. It has no maximum length.</LI>
<li><i>'Email Address'</i>: This will appear as hyperlink associated with the user's name.  </li>
<li><i>'Upload directory on the server'</i>: Subdirectory in the user's home directory on the server, to upload files to teh database</li>
<li><i>'Download directory on the server'</i>: Subdirectory in the user's home directory on the server, in which the database can return files to the user</li>
<LI><I>'Login name'</I>: Login name of the new user. You cannot add a user with a login name which already exists. It has to be 20 caracters or less, no spaces please.</LI>
<LI><I>'Password'</I>: Type the password of the new user. It has to be 20 caracters or less.</LI>
<LI><I>'Password re type'</I>: Type here the same password as you typed above. A new user is only added if the two passwords are the same. This is to reduce the risk of typingerrors.</LI>
<?php
if ($S_STATUS == $G_SUPER):
?> 
<LI><I>'Group'</I>: Select the group you want the new user to belong to. If you want to add him to a 
group which doesn't exist go to the <B>admin groups</B>-button on the menu at 
the left handside of your computerscreen. <A HREF="#addgroup">More information how to add a group</A>. 
After you have added a new group you can press the <B>admin users</B>-button again, click on 
<B>add a user</B> and fill in the data again. Now you can selected your just added group.</li> 
<LI><I>'Group-admin'</I>: Select this checkbox if you want to give the new user groupadmin rights.</LI>
<?php
endif; //($S_STATUS == $G_SUPER)
?> 
<li><i>'User'</i>:Select this checkbox for all 'normal' users.</li>
<li><i>'Guest'</i>:Select this checkbox if the new users should be able to view images from your group, but not upload new images.</li>
</ul>


<A NAME="modifyuser"><H3>Modify a User</H3></A>
<P>
To modify users click on <B>modify</B> on the right of the user you want to modify. 
Then you can modify the settings of this user and when you are finished press the button <B>Modify User</B>. You 
will get a message that the user has been modified. For more information how to fill in the data see 
<A HREF="#useradd">add a user</A>.
</P>

<A NAME="userdel"><H3>Delete a User</H3></A>
<P>
To delete the user click on <B>delete</B> on the right of the user you want to delete. 
If the user does not have images left in the database, you will be prompted wether or not to proceed removing the user.
If the user has only private pictures in the database, these will be deleted when you remove the account (you will be informed of the fact that the user has such private images).
If the user also has images that can be seen by others, you will be presented with three choices:  You can <B>inactivate</B> the account (remove public images, disable logins into the account, but keep public images), you can <B>Delete</B> the account (with all the images deposited by the user), or bail out of this operation (<B>Cancel</B>).

To check wether the users really have been removed from the database click again on to 
the <B>Users</B> button on the menu on the left. 
</P>

<a name="auditor"><h3>Auditors</h3></a>
<p>Auditors are users on the system that belong to other groups, but who are given the same rights as members of your own group to look at images belonging to members of your group. Thus, they can see all images of your group as if they were just another group member.  When an auditor uploads an image, however, it will belong to the auditor's group, and not yours.  To create an auditor (better called voyeur) click on the link, choose the name of the person (only one at the time) to become auditor, and click the 'create guest' button.  Removing auditors should be straight forward.</p> 

<?PHP  
endif; 
if ($S_STATUS == $G_SUPER): 
?> 

<A NAME="admingroups"><H2>GroupAdmin</H2></A>
<P>
Here you see the groups already defined and which users each group has. Here you can add or delete a group.<BR>
How to <A HREF="#addgroup">add a Group</A><BR>
How to <A HREF="#groupdel">delete a Group</A>

</P>
<A NAME="addgroup"><H3>Add a Group</H3></A>
<P>
To add a group click on <B>add a Group</B>. Then you can give a group name and press <B>Add Group</B>. 
You will get a message that your group has been added. To check whether your group really has been added to the 
database you can click on to the <B>Admin Groups</B>-button on the menu on the left.<BR>
</P>
<A NAME="groupdel"><H3>Delete a Group</H3></A>
<P>
To delete a group you can click on <B>delete</B>. 
After you confirm that you want to delete the group, you will get a message that the group has been removed. 
If the group still have users, you must first delete all the users that are in that group, 
as described in the Admin users section.
</P>

<?PHP
endif; 
?>
<HR>
<A NAME="mypictures"><H2>My Pictures</H2></A>
<P>
By clicking on <B>My Pictures</B>, you will see the images that you have uploaded (this function does a <A HREF="#search">search</A> on the database, looking for images that you uploaded). 

</P>

<hr>
<A NAME="template"><H2>Templates</H2></A>
<P>
Templates are nothing but a set of pre-defined meta-data.  The information eneterd into a template cna be called up anytime you upload an image.  You can define as many tenplates as you wish.  You may also change them, or delete them as you please.  Efficient use of templates make it painless to administer your image meta-data well.</P>
<P>Pressing the template button on the left yields a list with the templates you defined. From here you can also create new templates.</P>   

<A NAME="new"><H3>In case you selected <B>New template</B></H3></A>
<P>

<LI><A HREF="#notemplatename"> Please fill in the templatename</A></LI>
<LI><A HREF ="#doubletemplate"> This templatename exists already please choose another name</A></LI>
<P>Templates present all fields available in the database (for 2-D and 3-D images).  If you plan to use the tenplate only for 2-D images, just ignore the fields specific to 3-D images.  The fields are described in detail in the <A HREF="#Upload">Upload</A> section.</P>
</P>
<P>
<A NAME="notemplatename"> </A>
<A NAME ="doubletemplate"></A>
<B><I>Warning</I></B>: Each template has its own individual name. Therefore, you must name your new template.
<B><I>Choose a name you haven't used before!</I></B> 
<BR>
It is not a problem if you don't fill in all the data, but<B><I>the templatename has to be filled in!</I></B>. 
<BR>
Please note that when you fill in as many of the fields possible you'll be able to find your image more easily.
</P>

<P>
After you filled in all the fields that you want or that are required,
click on the <B>add</B>-button to continue. You will see the same screen
as if you selected an existing template. 
</P>
<A NAME ="nolocation"></A>
<A NAME= "template"><H3>In case you selected an existing template name</H3></A>
<P>
Just enter another (new) name.
</P>
<A NAME="modifytemplate"><H3>Modify a template</H3></A>
<P>
To modify templates click on <B>modify</B> on the right of the template you want to modify. 
Then you can modify the settings of this template and when you are finished press the button <B>Modify Template</B>. You 
will get a message that the template has been modified. For more information how to fill in the data see 
<A HREF="#upload">Upload</A>.
</P>

<A NAME="deltemplate"><H3>Delete a template</H3></A>
<P>
To delete the template click on <B>delete</B> on the right of the template you want to delete. After you confirm 
that you want to delete the template, you will get a message that the template has been removed. To add a new template see
<A HREF ="#upload">Upload</A>
</P>
<hr>
<a name="project"><h2>Projects</h2></a>
<p>
Projects add another level to organize your images.  Every image can belong to aproject.  Projects can contain subprojects (which can contain subprojects, etc..).  You may think of Projects as the folders/directories in computer's filesystem.  </p>
<p>
Create a new project by pressing the 'New Project' button.  Enter a (unique) name for the project, a description, and upload an image (in any of the <a href=convert_info.php>supported formats</a>) facilitating recognition of the project.   
</p>
<p>
Clicking on the name or image of a project will bring you to that specific project.  Here, you can view, edit, or delete the project or create sub-projects.  Buttons are provided that bring you to the images associated with the project or all the images associated with the project and all of its sub-projects. 
</p>
<HR>
<A NAME="profile"><H2>Settings</H2></A>
<P>
In <B>Settings</B> you can change your password and set other essentials.
</P>
<A NAME="imagedir"><H3>Image directory on the server</H3></A>
<P>The image directory on the server is the directory (folder) where the database will look for incoming files. If you have a 'home directory' on the server (if you don't know, ask) you can make a folder there and enter the name of that folder here. Now you can not only do an HTML file upload, but also 'move' files from this specific folder into the database. Therefore, you can save a file directly from the application you use to acquire the image into this folder, and move the file into the database.  The database will actually try to remove the file after you entered it succesfully into the database.   
<A NAME="changepwd"><H3>Change password</H3></A>
<P>
To change your password click on <B>Settings</B>. Type your new password and retype it to reduce the risk of typing errors. 
Your password must be 10 characters or less.
When you are finished press the button <B>Modify User</B>. You will get the message that the user (you) has been modified (silly message;).
</P>
<HR>
<a name="keyword"><h2>Keywords</h2></a>
<p>
This will list the keywords you can choose from.  Keywords are shared among all users belonging to one group. <br>
<b>Add</b> new keywords to the list by entering a new keyword in the appropriate box and pressing 'Add Keyword'.  <br>
Keywords can only <b>Deleted</b> when they are not assigned by an image.  The keywords that can be deleted are listed in the box next to the button 'Delete Keyword(s)'.  Select the keyword to be deleted and press the button.
</p>


<hr>
<A NAME="index"><H2>Log out</H2></A>
<p>The best and easiest way to log out is to close the browser completely (including any window you might have opened). If you have multiple accounts and want to log in as another user, you might want to press the 'Log out' button.  You will be presented with another 'login' dialog.  With the 'old' username fill in no or a phony password and click 'OK'.  After this erroneous login, click 'cancel'.  Subsequently, click the blue 'login' button and login under the other account.  This procedure might be a little different depending on the browser. </p>
<p><b>Never leave your computer unattended while logged into the database</b>. Your images, and possibly those of others, might be at risk!. </p>

<P>
<hr>
<A NAME="deconvolve"><H2>Image deconvolution</H2></A>
<p>Deconvolution is a mathematical operation used in image restoration to recover an object from an image that is degraded by blurring and noise. In microscopy the blurring is largely due to diffraction limited imaging by the instrument; the noise is usually photon noise. Read more about deconvolution on the <a href="http://support.svi.nl/wiki/DoingDeconvolution">SVI-wiki</a>.</p>
<p>If you have a valid license for <a href="http://support.svi.nl/wiki/HuygensScripting">Huygens Scripting</a>, you can run deconvolution on the images of the database that you are allowed to see. Provide the requested parameters and let it run. A question mark by every parameter gives you an explanation of what it means or how to estimate the best value.</p>
<hr>
<BR>
Created by <a href="mailto:nicos@itsa.ucsf.edu">Nico Stuurman</a>.  Last modified: $Id: help.php,v 1.24 2005/11/17 14:40:54 jose-v Exp $. 
</P> 

<?PHP
printfooter(); 
?>
