<?php

  // class-email.php - Takes care of upload notifications by email.
  // class-email.php - author: Frank Keijzers

  /***************************************************************************
  * This file handles upload notifications by email.                         *
  *                                                                          *
  * Authors: SVI group University Utrecht and Nico Stuurman                  *
  * email: nicos@itsa.ucsf.edu                                               *
  * demo at: http://sidb.svi.nl/                                             *
  * Copyright (c) 2000, 2001 by Nico Stuurman, 2004 Frank Keijzers           *
  * ------------------------------------------------------------------------ *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/

////
// !class to set and send email information for upload notifications.
class Email
{
    /*
     * Since image is uploaded to the server successfully,
     * we can send an email to one email address that a
     * new upload was done. We do need to check if the user
     *  who uploaded the file is in the list of users for 
     * which we want to get an upload email.
     */  
    function Email($image, $excl = 1)
    {

/*
	global $S_LOGIN, $emailNotifyList;

	if (strstr($emailNotifyList,$S_LOGIN))
	{
	    $this->sendEmail($image);
	}
	else 
	{
	}
*/


        global $session, $emailNotifyList, $emailExcludeList, $remoteuser;
        global $emailSysAdmin, $S_LOGIN;
        
        $sendIt = false;
        
        if ($excl) {
        
        // Check for Notification list
        
        if (trim(strtolower($emailNotifyList)) == "all")
            $sendIt = true;
        elseif (strstr($emailNotifyList,$S_LOGIN))
                  $sendIt=true;

	}

        // Check for Exclusion list                           
                                                              
                                                              
        if (trim(strtolower($emailExcludeList)) == "all")     
            $sendIt = false;                                  
        elseif (trim(strtolower($emailExcludeList)) == "none") {
            $sendIt = $sendIt;                                
        }                                                     
                                                              
        elseif (strstr($emailExcludeList,$S_LOGIN))
			      $sendIt=false;
                                                              
                                                              
        if ($sendIt)                                          
        {                                                     
            $this->sendEmail($image);
        }                                                     
	
    }

    function sendEmail($image)
    {
	global $S_LOGIN, $emailNotifyList, $emailExcludeList;
	global $emailNotifyAddress, $emailSenderAddress;

        $recipient = $emailNotifyAddress;

        $subject = "SIDB upload notifyer";

	$time = time();
	$timestringDay  = date("l", $time);
	$timestringDate = date("dS of F Y", $time);
	$timestringTime = date("H:i T", $time);

        $message = "Hello,".
	           "\n\n".
	           "Just wanted to inform you that an image is uploaded:\n\n".
                   "user  : $S_LOGIN\n".
                   "image : $image\n".
	           "time  : $timestringTime on $timestringDay the $timestringDate.".
	           "\n\n".
		   "Your current notification list includes: ".
                   "\"$emailNotifyList\"\n".
                   "and excludes: ".
                   "\"$emailExcludeList\"\n\n".
		   "Later!\n\n".
		   "Your SIDB upload notifyer";


        $headers = "From: SIDB <$emailSenderAddress>\r\n".
                   "Organization: Scientific Volume Imaging\r\n".
                   "X-URL: http://www.svi.nl/\r\n".
                   "Sender: $emailSenderAddress\r\n".
                   "Errors-To: $emailSenderAddress\r\n";

        mail($recipient, $subject, $message, $headers);
    }

}
