<?php
   
// functions_inc.php - Functions of use to multiple scripts  
// functions_inc.php - author: SVI group University Utrecht and Nico Stuurman
  /***************************************************************************
  * This file contains all basic and common functions needed by the php      *
  * scripts for administration of users and groups.                          *
  * Update by Frank on 29-06-2000. Update some functions.                    *
  * Updated by Nico on 14-08-2000.  Added function list and set_user_settings*
  * Update by Nico on 17-08-2000.  Added extra checks in                     *
  *    del_user_from_database                                                *
  *                                                                          *
  * Updated by David 09-08-2002. Add subdirectory reading functions          *
  * and MD5 checksums                                                        *
  ****************************************************************************
  *                          FUNCTION LIST                                   *
  * do_error($errorstring)                                                   *
  * db_NumRows ($result)                                                     *
  * db_NumFields ($result)                                                   * 
  * db_FieldName ($result,$field_number)                                     * 
  * db_Fetch_Array ($result,$row)                                            * 
  * db_Fetch_Row ($result,$row)                                              * 
  * db_Result ($result,$rownr,$fieldname)                                    * 
  * db_exec($db_query)                                                       * 
  * do_database_query($db_query)                                             *
  * get_image_info ($imageid, $column)                                       *
  * match_image_md5 ($md5sum)                                                *
  * get_template_info ($templateid, $column)                                 *
  * get_project_info($projectid, $column)                                    * 
  * get_project ($id, $type)                                                 *
  * get_trust_array ($imageid)                                               * 
  * get_filename_extension ($filename) {                                     *
  * get_mime_type ($extension) {                                             *
  * get_user_info($userid, $column)                                          *
  * get_audit_groups ($userid) {                                             *
  * get_user_space ($userid)                                                 *
  * get_all_users ()                                                         *
  * get_valid_user ($userid)                                                 *
  * file_checksum ($filename)                                                *
  * get_upload_dir ()                                                        *
  * get_group_info($groupid, $column)                                        *
  * get_group_space ($groupid)                                               *
  * get_group_users($groupid)                                                *
  * get_group_admins($groupid)                                               *
  * set_user_settings($userid, $settings)                                    *
  * set_image_settings ($id, $settings)                                      *
  * get_image_settings ($id)                                                 *
  * get_unix_time ($time_string)                                             *
  * get_array_value ($array)                                                 *
  * exist_user ($login)                                                      *
  * add_user_to_database($login, $pwd, $groupid, $real_name, $status)        *
  * del_user_from_database($userid)                                          *
  * add_group_to_database($groupname)                                        *
  * del_group_from_database($groupid)                                        *
  * box_users()                                                              *
  * find_projects ($projectid)                                               *
  * list_progeny ($projectid, $level, $selected_id)                          * 
  * box_projects ($selected_id, $message, $whereclause=false,                *
  *                     $arrayname="project_array[]", $multiple=false)       *
  * box_type ($text)                                                         *
  * is_uploaded ($filename)                                                  *
  ****************************************************************************
  *                                                                          *
  * Authors: SVI group University Utrecht and Nico Stuurman                  *
  * email: stuurman@rulbim.leidenuniv.nl                                     *
  * demo at: https://impi.leidenuniv.nl                                      *
  * Last modified 12/25/00                                                   *
  * Copyright (c) 2000 by Nico Stuurman                                      *
  * ------------------------------------------------------------------------ *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/         

////
// !print fatal errormessage to user
function do_error($errorstring){
   echo "Illegal operation performed!<br>\n";
   echo "Reported error:<br>\n";
   echo $errorstring."<br>\n";
   echo "Errormessage reported from database:<br>\n"; 
   echo pg_errormessage()."<br>\n";
   //printfooter();
   //exit;
}

////
// !Return number of rows from a database result
function db_NumRows ($result) {
   return @pg_NumRows ($result);
}

////
// !Return number of fields from a database result
function db_NumFields ($result) {
   return @pg_NumFields ($result);
}

////
function db_FieldName ($result,$field_number) {
   return @pg_FieldName ($result,$field_number);
}

////
// !Fetches a row from a database result
function db_Fetch_Array ($result,$row) {
   return @pg_Fetch_Array ($result,$row);
}

////
// !Fetches a row from a database result
function db_Fetch_Row ($result,$row) {
   return @pg_Fetch_Row ($result,$row);
}

////
function db_Result ($result,$rownr,$fieldname) {
   return @pg_Result ($result,$rownr,$fieldname); 
}
   
////
function db_exec($db_query) {
   return do_database_query($db_query);
}

////
// !execute database query or halt on error
function do_database_query($db_query) {
   global $SQL_log;

   if ($SQL_log) {
      $logfile = fopen ($SQL_log, "a+");
      if ($logfile) {
         fwrite ($logfile, $db_query . "\n");
         fclose ($logfile);
      }
   } 

   if (!$db_result = @pg_exec($db_query)) {
      $db_error = "Could not execute query <b>$db_query</b>!";
      do_error($db_error);
      return false;
   }
   else
      return $db_result;
}

////
// !function to retrieve image info
function get_image_info($imageid, $column) {
   $db_query = "SELECT $column FROM images WHERE imageid='$imageid'";
   $db_result = do_database_query($db_query);
   $db_rows = db_numrows($db_result);

   if ($db_rows == 1):
      $db_row_result = db_fetch_array($db_result,0);
      return $db_row_result["$column"];
   else:
      return false;
   endif;
}

////
// !returns an array of image ids which match the particular checksum.
//
function match_image_md5 ($checksum) 
{
   $db_query = "SELECT i.imageid as iid,u.real_name as uname FROM ".
   "images i, users u WHERE i.md5sum='$checksum' AND i.userid=u.userid";
   $db_result = do_database_query($db_query);
   $db_rows = db_numrows($db_result);
   $carr=array();
   for ($c=0;$c<$db_rows;$c++) {
      $db_row_result = db_fetch_array($db_result,$c);
      $carr[$db_row_result["iid"]]=$db_row_result["uname"];
   }
   return $carr;   
}

////
// !retrieves a single value from table templae
function get_template_info ($templateid, $column) { 
   $db_query = "SELECT $column FROM template WHERE templateid='$templateid'";
   $db_result = do_database_query($db_query);
   $db_rows = db_numrows($db_result);

   if ($db_rows == 1):
      $db_row_result = db_fetch_array($db_result,0);
      return $db_row_result["$column"];
   else:
      return false;
   endif;
}

////
// !function to retrieve project info
function get_project_info($projectid, $column) {
   $db_query = "SELECT $column FROM projects WHERE projectid='$projectid'";
   $db_result = do_database_query($db_query);
   $db_rows = db_numrows($db_result);

   if ($db_rows == 1):
      $db_row_result = db_fetch_array($db_result,0);
      return $db_row_result["$column"];
   else:
      return false;
   endif;
}

////
// !returns project associated with $id.  type is images or template
function get_project ($id, $type) {
   if ($type == "images")
      $query = "SELECT projectid from projectximages WHERE imageid='$id'";
   elseif ($type == "template")
      $query = "SELECT projectid from projectxtemplate WHERE templateid='$id'";
   $result = do_database_query ($query);
   $i=0;
   $found = db_Fetch_array($result,$i);
   while ($found) {
      $project[]=$found["projectid"];
      $i++;
      $found = db_Fetch_Array ($result, $i);
   }
   return $project;   
   
/*   if (db_NumRows ($result) == 1) {
      $found = db_Fetch_Array ($result, 0);
      return  $found["projectid"];
   }
   return false;
*/
}


////
// !returns an array with userid trusted to see this image. 
function get_trust_array ($imageid) {
   $query = "SELECT userid from imagextrust WHERE imageid='$imageid'";
   $result = do_database_query ($query);
   $i=0;
   $found = db_Fetch_array($result,$i);
   while ($found) {
      $trust[]=$found["userid"];
      $i++;
      $found = db_Fetch_Array ($result, $i);
   }
   return $trust;
}
 
  
////
//  !returns the uppercase of chars after last dot
function get_filename_extension ($filename) {
   $lastdot = strrpos ($filename, ".");
   $ext_length = strlen ($filename)-$lastdot +1; 
   $extension = substr ($filename, $lastdot + 1, $ext_length);
   $extension = strtoupper ($extension);
   return $extension;
}

////
// !queries the database for a mime-type given a filename extension
function get_mime_type ($extension) {
   if (is_string ($extension)) {
      $db_query = "SELECT mime FROM mime WHERE extension='$extension';";
      $db_result = do_database_query ($db_query);
      $db_rows = db_numrows ($db_result);

      if ($db_rows == 1) {
         $db_row_result = db_fetch_array($db_result,0);
         return $db_row_result["mime"];
      }
   }
} 

////
// !function to retrieve given user info
function get_user_info($userid, $column) {
   $db_query = "SELECT $column FROM users WHERE userid='$userid'";
   $db_result = do_database_query($db_query);
   $db_rows = db_numrows($db_result);

   if ($db_rows == 1):
      $db_row_result = db_fetch_array($db_result,0);
      return $db_row_result["$column"];
   else:
      return false;
   endif;
}

////
// !returns an array with groups to which given userid has auditing rights
function get_audit_groups ($userid)
{
    $db_query = "SELECT groupid FROM auditors WHERE userid='$userid';";
    $db_result = do_database_query($db_query);
    $db_rows = db_numrows($db_result);

    if ($db_rows == 0)
    {
	return FALSE;
    }
    else
    {
        for ($i = 0; $i < $db_rows; $i++)
	{
            $db_row_result = db_fetch_array($db_result, $i);
            $audit_groups[$i] = $db_row_result["groupid"];
        }
        return $audit_groups;
    }
} 

////
// !function to determine how much disk space a user uses
function get_user_space ($userid) {
   $db_query = "SELECT SUM(filesize) FROM images WHERE userid='$userid';";
   $db_result = do_database_query($db_query);
   if ($db_row_result = db_fetch_array ($db_result,0))
      return $db_row_result[0];
   else
      return false;
}
   
////
// !function to retrieve given group info
function get_group_info($groupid, $column) {
   $db_query = "SELECT $column FROM groups WHERE groupid='$groupid' ;";
   $db_result = do_database_query($db_query);
   $db_rows = db_numrows($db_result);

   if ($db_rows == 1):
      $db_row_result = db_fetch_array($db_result,0);
      return $db_row_result["$column"];
   else:
      return false;
   endif;
}

////
// !function to determine disk space occupied by group
function get_group_space ($groupid) {
   // first get all users in group
   $db_query = "SELECT userid FROM users WHERE groupid='$groupid';";
   $db_result = do_database_query($db_query);
   $num_rows = db_numrows($db_result);
   if ($num_rows > 0) {
      for ($i=0; $i < $num_rows; $i++) {
         // for each userid, find out the space in use and add to total
         $db_row_result = db_fetch_array($db_result,$i);
         $space += get_user_space ($db_row_result["userid"]);
      }
   }
   else return 0;
   return $space;
}

////
// !function to get all users not being admins beloging to group
function get_group_users($groupid) {
   $db_query = "SELECT * FROM users WHERE groupid='$groupid' AND NOT status='1'";
   $db_result = do_database_query($db_query);
   return $db_result;
}

////
// !function to retrieve all admins of group
function get_group_admins($groupid) {
   global $G_ADMIN;
   $db_query = "SELECT * FROM users WHERE groupid='$groupid' AND status='$G_ADMIN'";
   $db_result = do_database_query($db_query);
   return $db_result;
}

////
// !writes the current users settings into the database
function set_user_settings ($userid, $settings) {
   if ($serial_settings = serialize ($settings) ){
      $db_query = "UPDATE users SET settings='$serial_settings' WHERE userid='$userid';";
      $db_result = do_database_query ($db_query);
      return db_result;
   }
   return false;
}

////
// !writes the current images settings into the database
function set_image_settings ($id, $settings) {
   if ($serial_settings = serialize ($settings) ){
      $db_query = "UPDATE images SET settings='$serial_settings' WHERE imageid='$id';";
      $db_result = do_database_query ($db_query);
      return $db_result;
   }
   return false;
}

////
// !reads the current images settings from the database
function get_image_settings ($id) {
   $db_query = "SELECT settings FROM images WHERE imageid='$id';";
   $db_result = do_database_query ($db_query);
   if ($db_row_result = db_fetch_array ($db_result,0))
      return unserialize ($db_row_result["settings"]);
   return false;
}

////
// !return unix timestamp given a defined string defined in $date_format
function get_unix_time ($time_stamp) {
   global $date_format;

   if ($date_format == "m-d-Y") {
      $month = strtok ($time_stamp, "-/");
      $day = strtok ("-/");
      $year = strtok ("-/");
   }
   elseif ($date_format == "d-m-Y") { 
      $day = strtok ($time_stamp, "-/");
      $month = strtok ("-/");
      $year = strtok ("-/");
   }
   else {
     echo "Error: wrong call to get_unix_time.<br>";
      return false;
   }

   // change 20 into 21 on Dec. 31 2099, please
   if (strlen($year) == 2)
      $year = "20" . $year;  
 
   if (checkdate ($month, $day, $year))
      return mktime (0, 0, 0, $month, $day, $year);
   else 
      return false;
}

////
// !useful to extract select value from selection boxes
function get_array_value ($array) {
   if ($array && is_array($array)) 
      while (list(, $value) = each ($array)) {
         $result = $value;
      }
   return $result;
}

////
// Determines whether a given login name exists
function exist_user ($login) {
   $db_query = "SELECT * FROM users WHERE login='$login'";
   $db_result = do_database_query($db_query);
   $db_rows = db_numrows($db_result);
   if ($db_rows > 0)
      return true;
   else
      return false;
}

/*
////
// !function to add user to database
function add_user_to_database($login, $pwd, $groupid, $real_name, $status) {
   // if user does not exist
   if ( !exist_user($login) ) {
      // add user to database
      $db_query = "INSERT INTO users(loupid, status) VALUES('$login', '".crypt_password($pwd)."', '$real_name', '$groupid', '$status')";
      do_database_query($db_query);
      return true;
   }
   // users login name already exists
   else
      return false;
}
*/


////
// !function to delete user from database
function del_user_from_database($userid) {

   // set database query to check for user
   $db_query = "SELECT login, groupid, real_name FROM users WHERE userid='$userid'";
   $db_result = do_database_query($db_query);
   $db_rows = db_numrows($db_result);

   // if user exists
   if ($db_rows == 1):

      // final check whether current user has the right to do this nasty thing
      $db_row_result = db_fetch_array ($db_result, 0);  
      
      if ( ($S_GROUPID==$db_row_result["groupid"]) || ($S_GROUPID==0) ) {  
      
          // delete user from database
          $db_query = "DELETE FROM users WHERE userid='$userid'";
          if (do_database_query($db_query)) {
             // echo "The account of <b>$db_row_result["real_name"]</b> has been removed<br>";
             // return true on success
             return $db_row_result["real_name"];
          }
          else
             return false;
       }
       // although it should not be possible to be unauthorized here...
       else
          return false;

   // users login does not exist
   else:

      // return false on failure
      return false;

   endif;
}

////
// !function to add group to database
function add_group_to_database($groupname) {

   // set database query to check for user
   $db_query = "SELECT groupid FROM groups WHERE groupname='$groupname'";
   $db_result = do_database_query($db_query);
   $db_rows = db_numrows($db_result);

   // if group does not exist
   if ($db_rows == 0):

      // add user to database
      $db_query = "INSERT INTO groups(groupname, adminid) VALUES('$groupname', -1)";
      do_database_query($db_query);

      return true;

   // groupname already exists
   else:

      return false;

   endif;
}

////
// !function to delete user from database
function del_group_from_database($groupid) {

   // set database query to check for user
   $db_query = "SELECT groupname FROM groups WHERE groupid='$groupid'";
   $db_result = do_database_query($db_query);
   $db_rows = db_numrows($db_result);

   // if user exists
   if ($db_rows == 1):

      // delete group from database
      $db_query = "DELETE FROM groups WHERE groupid='$groupid'";
      do_database_query($db_query);

      // return true on success
      return true;

   // groupname does not exist
   else:

      // return false on failure
      return false;

   endif;
}

////
// !Returns true if the userid exists.
//
function valid_user ($userid) {
    $uarr=get_all_users();
    if (isset($uarr[$userid]))
       return true;
    else
       return false;
}

////
// !Returns an array of usernames (login) indexed by userid
//
function get_all_users () {
	$uarr=array();
	$query="SELECT userid,login,real_name FROM users ORDER BY login";
	$result = do_database_query($query);
	$usercount = db_numrows($result);
	for ($u=0; $u<$usercount;$u++){
		$uid=db_result($result,$u,"userid");
		$urn=db_result($result,$u,"real_name");
		$logid=db_result($result,$u,"login");
		$uarr[$uid] = "$urn ($logid)";
	}
	return $uarr;
}

////
// !Returns an array of usernames (login) for given admin indexed by userid
//
function get_all_group_users ($groupid) {
	$uarr=array();
	$query="SELECT userid,login,real_name FROM users ".
	       "WHERE groupid='$groupid' ".
	       "ORDER BY login";
	$result = do_database_query($query);
	$usercount = db_numrows($result);
	for ($u=0; $u<$usercount;$u++){
		$uid=db_result($result,$u,"userid");
		$urn=db_result($result,$u,"real_name");
		$logid=db_result($result,$u,"login");
		$uarr[$uid] = "$urn ($logid)";
	}
	return $uarr;
}

////
// !Returns an array of valid upload directories for a given user.
//
function get_upload_dir () 
{
   global $S_USERID,$G_SUPER,$G_ADMIN,$S_STATUS, $S_HOMEDIR,$people_dir,$common_upload_dir,$infolder;

   $darr=array();
   echo "<!-- HOMEDIR = $S_HOMEDIR -->\n";
   if (file_exists($S_HOMEDIR)) {
      $sarr=get_subdirectories($S_HOMEDIR);
      for (reset($sarr); list($key,$val)=each($sarr); ) {
         $shortval=str_replace($S_HOMEDIR."/" ," ",$val);
         $darr[$val]= "Personal: ".$shortval;
      }
   }

   //If the user is admin, allow upload from the common area
   if (($S_STATUS == $G_SUPER ||$S_STATUS ==$G_ADMIN) && file_exists($common_upload_dir)) {
      $sarr=get_subdirectories($common_upload_dir);
      for (reset($sarr); list($key,$val)=each($sarr);) {
         $shortval=str_replace($common_upload_dir,"",$val);
         $darr[$val]= "Common: ".$shortval;
      }
   }
   return $darr;		
}

//// 
// !Returns the subdirectories of a directory as an array
//
function get_subdirectories ($parent) 
{
   $farr=array();
   if ( is_dir($parent) && is_readable($parent)){
      $farr[]=$parent;
      $handle=opendir($parent);
      while ($subdir=readdir($handle)){
         if ($subdir != "." && $subdir !=".." && $subdir !=".AppleDouble"){
            $sarr=get_subdirectories($parent."/".$subdir);
            for(reset($sarr);list($key,$val)=each($sarr);){
               $farr[]=$val;
            }
         }	 
      }
      closedir($handle);
   }
   return $farr;
}

if (!function_exists("md5_file")) {
////
//!Returns an MD5 checksum of a file.
//  Duplicates sometimes build in md5_file(), 
function md5_file ($filename) 
   {
      // filename should be an absolute path.
      $res=array();
      $checksum="";
      if (file_exists($filename)){
         exec("md5sum $filename",$res);
         $bits=split(" +",$res[0]);
         if (strlen($bits[0])==32) {
            $checksum=$bits[0];
         }
      }
      return $checksum;
   }
}

////
// !Displays box to select users (to be trusted or to audit).
// Needs to be called from within a form and table
function  box_users ($selected_id, $message, $whereclause=false, 
                     $arrayname="trust_array[]",$multiple=false) {
   $query = "SELECT userid,real_name FROM users $whereclause 
             ORDER BY real_name;";
   $result = do_database_query ($query);
   $numrows = db_NumRows ($result);
 
   if ($numrows==0)
      return false;
 
   if (!$selected_id) 
      $selected_id = 0;
   if (!is_array($selected_id)) {
      $temp[0]=$selected_id;
      $selected_id=$temp;
   }
   if (!($message))
      $message = "Select the person:";
   if ($multiple)
      $size="size=8";
   else
      $size="size=1";

   echo "<TR><TD>$message</TD>\n";
   echo "<TD><SELECT $multiple $size name=\"$arrayname\">\n";
   echo "<OPTION value='0'></OPTION>\n";

   for ($i=0; $i < $numrows; $i++) {
      $userid = db_result($result, $i, 'userid');
      $real_name = db_result ($result, $i, 'real_name');
      if (in_array($userid,$selected_id))
         echo "<OPTION selected value=\"$userid\">$real_name</OPTION>\n";
      else
         echo "<OPTION value=\"$userid\">$real_name</OPTION>\n";
   }
 
   echo "</SELECT></TD>\n"; 
   return true;
}

////
// !returns an array with projectids
// daugther projects when an id is given, otherwise top-level projects
function find_projects ($projectid) {
   global $S_USERID;

   $rightquery = projright_query ($S_USERID, "projectid", false);

   if (! $projectid) {
      $query = "SELECT projectid FROM projects WHERE projectid IN ($rightquery) 
                 AND (( projectid NOT IN (
                  SELECT daughterid FROM projectxprojects) ) OR ";
      // daughters whose mothers may not be seen by this user
      $query .= "(projectid IN (SELECT daughterid FROM projectxprojects WHERE 
                  motherid NOT IN ($rightquery) ) )) ORDER BY name;";
   }
   else {
      $query = "SELECT projectid FROM projects WHERE projectid IN 
                (SELECT daughterid AS projectid FROM projectxprojects WHERE 
                motherid=$projectid AND daughterid IN ($rightquery) )
                ORDER BY name;";
   }
   $result = do_database_query ($query);

   for ($i = 0; $i < db_NumRows ($result); $i++) 
      $array[$i] = db_Result ($result, $i, "projectid");
   return $array;
}

////
// !recursive method to find all descendants.  
// Returns the ids in an array 
function find_desc_projects ($projectid) {
   $sons = find_projects ($projectid);
   $result = $sons;
   if ($sons) {
      for ($i=0; $i < sizeof($sons); $i++) 
         $result = array_merge ($result, find_desc_projects($sons[$i]));
   }
   return $result;
}

////
// !recursive method to list progeny projects in a box
function list_progeny ($projectid, $level, $selected_id) {
   $level += 1;
   for ($i=0; $i<$level; $i++)
      $filler .= "&nbsp&nbsp";
   if ($projectid)
      $sons = find_projects ($projectid);
   if ($sons) {
      for ($i=0; $i<sizeof($sons); $i++) {
      $name = get_project_info ($sons[$i],"name");
      if (is_array($selected_id) && in_array ($sons[$i], $selected_id) )
         echo "<OPTION selected value=\"$sons[$i]\">$filler $name</OPTION>\n";
      else
         echo "<OPTION value=\"$sons[$i]\">$filler $name</OPTION>\n";
      list_progeny ($sons[$i], $level, $selected_id);
      }
   }   
}   

////
// !Displays box to select projects (including sub-projects).
// Needs to be called from within a form and table
function  box_projects ($selected_id, $message, $whereclause=false, 
                        $arrayname="project_array[]", $multiple=false, $size=7) {
   // start at top level
   $top_array = find_projects (false);
   if (! $top_array)
      return false;

   if ($multiple)
      $multiple = "multiple";

   // so that single values as well as multiples can be dealt with
   if ($selected_id && ! is_array($selected_id)){
      $selected_id = array($selected_id);
   }

   echo "<td rowspan=5 valign='top'>$message<br>\n";
   echo "<SELECT $multiple size=$size name=\"$arrayname\">\n";
   echo "<OPTION value='0'></OPTION>\n";

   for ($i=0; $i<sizeof ($top_array); $i++) {
      // Add project to the box and add sub-projects (nested)
      $name = get_project_info ($top_array[$i],"name");
      if (is_array($selected_id) && in_array ($top_array[$i], $selected_id) )
         echo "<OPTION selected value=\"$top_array[$i]\">$name</OPTION>\n";
      else
         echo "<OPTION value=\"$top_array[$i]\">$name</OPTION>\n";
      list_progeny ($top_array[$i], 0, $selected_id);
   }

   echo "</SELECT></td>\n"; 
   return true;
}

////
// !lists available image/template types. 
function box_type ($text="") {
   global $IMAGE_TOOLS, $S_SETTINGS;
   // Displays select box for upload type. Pre-selects users previous choice

   echo "<SELECT NAME=\"filetype\" $text>\n";
   $result = db_exec("SELECT name FROM filetypes ORDER BY sortid;");
   $num = db_numrows($result);
   if ($IMAGE_TOOLS) {
      for ($i=0; $i<$num; $i++) {
         $row = db_fetch_array($result, $i);
         if ($row["name"]==$S_SETTINGS["filetype"])
            echo "<OPTION SELECTED 
                   VALUE=\"" . $row["name"] . "\">" . $row["name"] . "\n";
         else
      	    echo "<OPTION 
                   VALUE=\"" . $row["name"] . "\">" . $row["name"] . "\n";
      }
   }
   // when there is no need for 3-D images
   else {     
      for ($i=0; $i<$num; $i++) {
         $row = db_fetch_array($result, $i);
         if ($row["name"] != "3-D" && $row["name"] != "ICS") {
            if ($row["name"]==$S_SETTINGS["filetype"])
               echo "<OPTION SELECTED 
                      VALUE=\"" . $row["name"] . "\">" . $row["name"] . "\n";
            else
               echo "<OPTION 
                     VALUE=\"" . $row["name"] . "\">" . $row["name"] . "\n";
         }
      }
   }
   echo "</SELECT>\n";
}

////
// !is_uploaded_file is only available in php 4.02 and up
function is_uploaded ($filename) {
   global $people_dir;
   // when this is a move from a homedir, just check whether the file exists
   if (strstr($filename, $people_dir))
      if (file_exists($filename))
         return true;
   if (function_exists ("is_uploaded_file")) 
      return (is_uploaded_file ($filename));
   if (!$tmp_file = get_cfg_var('upload_tmp_dir')) {
      $tmp_file = dirname(tempnam('', ''));
   }
   $tmp_file .= '/' . basename($filename);
   /* User might have trailing slash in php.ini... */
   return (ereg_replace('/+', '/', $tmp_file) == $filename);
}


?>
