<?php

// show_inc.php - Displays images thumbnail plus metadata
// show_inc.php - author: SVI group University Utrecht and Nico Stuurman
  /***************************************************************************
  * This script is called from show.php and upload.php                       *
  * Apart from the normal global variables, $imageid needs to be set.        *
  * Checks whether the user may see the image.                               *
  *                                                                          *
  *                                                                          *
  * Authors: SVI group University Utrecht and Nico Stuurman                  *
  * email: stuurman@rulbim.leidenuniv.nl                                     *
  * demo at: https://impi.leidenuniv.nl                                      *
  * Copyright (c) 2001 by Nico Stuurman                                      *
  * ------------------------------------------------------------------------ *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/         

global $PHPSESSID;

// Test if user can view requested image.
if (imgviewrights($imageid, $S_USERID))
{
    // Print the image overview in a table.
    print("<table border=0 cellpadding=6 width=\"100%\">");
    print("<tr>");

    require ("$include_dir/show_base_inc.php");

    if ($use_imagej) 
    {
        if ($imagetype == "2-D")
        {
            $filetype_extension = get_image_info($id, "filetype_extension");
            if ($filetype_extension == "GIF" 
	        || $filetype_extension == "JPEG" 
	        || $filetype_extension == "TIFF")
	    {
                $args .= "&filetype_extension=$filetype_extension";
                print("<tr>");
	        print("<td align=\"center\">");
	        print("<a href=\"show.php?id=$imageid&try=imagej&imagetype=".
	              "$imagetype$args\">Edit $filename in ImageJ</a>");
	        print("</td></tr>");
            }
        }
    }

    $movie = "$thumbnail_dir/movie/".thumb_name($imageid, $thumb_nr, "mpg");
    $movie_web = "showthumb.php?id=$imageid&thumbnr=$thumb_nr&kind=movie";

    if ((($imagetype=="2-D") || ($imagetype=="other")) && $mime)
    {
        $linkstart = "<a href=\"download.php?imageid=$imageid&".
	             "imagetype=$imagetype&do_mime=true\">";
        $linkend = "</a>";
    }

    if ((($imagetype=="3-D" || ($imagetype=="ICS") || ($imagetype=="multipage"))
	&& @filesize($movie)))
    {
        $linkstart = "<a href=\"$movie_web\">";
        $linkend = "</a>";
    }


    // Start a new cell in the main image overview table.
    print("<td colspan=2>");
    // Provide the Previous, Back To Images and Next links in upper row of
    // table. Make the three links in a table to keep them aligned nicely.
    print("<table width=\"100%\">");
    print("<tr>");
    $searchquery = buildquery();
    $search_result = do_database_query($searchquery);
    for ($i = 0; $i < db_numrows($search_result); $i++)
    {
        $r = db_fetch_Array($search_result,$i);
        $imageids[$i] = $r["imageid"];
        if ($imageid == $imageids[$i])
	{
            $currentid_offset = $i;
	}
    }
    if (sizeof($imageids) > 1)
    {
        print("<td width=\"25%\" align=\"left\">");
        if ($currentid_offset > 0)
        {
            $previd = $imageids[$currentid_offset-1];
            print("<a href=\"show.php?id=$previd$args\">&lt;&lt; previous</a>");
        }
        else
        {
            print("&nbsp;");
	}
	print("</td>");
	print("<td width=\"50%\" align=\"center\">");
	print("<a href=\"search.php?".$args."\">back to images</a>");
	print("</td>");
        print("<td width=\"25%\" align=\"right\">");
        if ($currentid_offset < (sizeof($imageids)-1))
	{
            $nextid = $imageids[$currentid_offset+1];
            print("<a href=\"show.php?id=$nextid$args\">next &gt;&gt;</a>");
        }
        else
	{
            print("&nbsp;");
	}
        print("</td>");
    }
    print("</tr>");
    print("<tr><td colspan=3><hr></td></tr>");
    print("</table>");
    // End cell in main image overview table.
    print("</td>");

    // End old and start new row in the overview table.
    print("</tr><tr>");

    // Then we want to display the thumbnail on the left side.
    print("<td rowspan=2 align=\"left\" valign=\"bottom\">");
	if (@filesize(str_replace(".jpg","_1.jpg",$big_thumb)))
    {
        $multiv = true;
        #print("<td rowspan=2 align=\"left\" valign=\"top\">");
        print ("<table><tr><td align=\"left\" valign=\"top\">");
    }
    else 
    {
        $multiv = false;
    }
    // Display the thumbnail with it's link.
    // First check if it exists by retrieving its filesize.
    if (@filesize($big_thumb))
    {
    print("$linkstart");
    print("<img src=\"$big_thumb_web&PHPSESSID=$PHPSESSID\">");
    print("$linkend");

	   if ($multiv)
        {   print("</td><td>");
            print("<img src=\"$big_thumb_web&PHPSESSID=$PHPSESSID&view=1\">");
            print("</td></tr><tr><td>");
            print("<img src=\"$big_thumb_web&PHPSESSID=$PHPSESSID&view=2\">");
            print("</td><td>");
        }



        if ($imagetype <> "other")
        {
            // This piece of code will create an image with a size bar
	    // in it. This image will be put next to the thumbnail.
	    // The catch here is the PHP installation. It should be
	    // installed with the GD libraries. If it is not, nothing
	    // wrong happens. The creation with the file sizebar.php
	    // will check if the function names for creating images
	    // exist.

	    // Get size properties from image out of database.
            $db_query = "SELECT x_nm,x_thumb,x_pixel FROM images ".
	                "WHERE imageid='$id'";
            $db_id = db_exec($db_query);
            if ($db_id)
            {
                $db_result = db_fetch_array($db_id,0);
                if ($db_result)
                {
                    $x_size = $db_result["x_nm"];
                    $x_thumb = $db_result["x_thumb"];
                    $x_pixel = $db_result["x_pixel"];
                }
            }
	    // Test if result from database is good enough to actually
	    // make the image by calling the script sizebar.php for it.
            if ($x_size && $x_thumb && $x_pixel)
            {
                $ratio = $x_thumb / $x_pixel;
                print("<br>");
                print("<img src=\"sizebar.php?xsize=$x_size&ratio=$ratio\">");
            }
        }
        if ($multiv) {print("</td></tr></table>");}
    }
    else 
    {
	// Seems the thumbnail does not exist. If user is owner
	// of the image, then give an option to try to repair
	// the lost/broken thumbnail.
	if ($owner && $imagetype <> "other")
	{
	    print("Seems the thumbnail does not exist anymore.<br>You can ".
	          "<a href=\"show.php?id=$imageid&try=repair_thumb&".
	          "imagetype=$imagetype$args\">try to repair</a> it.</a>");
	}
    }
    print("</td>");
    // Then print the links to download the image, to have it 
    // displayed on a nice page that is printable.
    print("<td valign=\"top\" width=\"100%\">");
    // Print correct print-, download-, export- and movie-links.
    print("<a href=\"show_printable.php?id=$id$args\">show printable</a>");
    print("<br><br>");
    // For printing download link, make distinction in browsers.
    if ($client->browser == "Internet Explorer")
    {
        if ($client->OS == "Windows")
        {
            $click_type = "right";
            $action = "Save Target As...";
        }
        elseif ($client->OS == "Mac OS")
        {
            $click_type="control";
            $action = "Download Link to Disk";
        }
        if ($imagetype == "ICS")
        {
            print("<a href=\"download.php?imageid=$id&imagetype=$imagetype\">".
                  "download ics image ($click_type click and choose ".
                  "\"$action\")</a>");
            print("<br><br>");
	    print("<a href=\"download.php?imageid=$id&imagetype=ids\">".
                  "download ids image ($click_type click and choose ".
                  "\"$action\")</a>");
        }
        else
        {
            print("<a href=\"download.php?imageid=$id&imagetype=$imagetype\">".
                  "download image ($click_type click and choose ".
                  "\"$action\")</a>");
        }
    }
    else
    {
        if ($imagetype=="ICS")
        {
            print("<a href=download.php?imageid=$id&imagetype=$imagetype>".
                  "download ics image</a>");
            print("<br><br>");
            print("<a href=\"download.php?imageid=$id&imagetype=ids\">".
                  "download ids image</a>");
       }
       else
       {
            print("<a href=\"download.php?imageid=$id&imagetype=$imagetype\"'>".
                  "download image</a>");
       }
    }
    // Print link to export image to ICS in users homedir.
    if (($imagetype == "3-D"  || $imagetype == "ICS") && $S_OUTDIR) 
    {
	$temp_dir = basename ($S_OUTDIR);
	print("<br><br>");
	print("<a href=\"show.php?id=$imageid&try=save_ics&".
	      "imagetype=$imagetype$args\">export as ICS to your directory ".
	      "<i>$temp_dir</i></a>");
    }
    // Print link to export to movie.
    if ($make_rotating_movie)
    {
    if ( $imagetype == "3-D"  || $imagetype == "ICS" )
	{
	    print("<br><a href=\"show.php?id=$imageid&try=rotate_3D\">".
		  "export to movie of rotating image</a>");
	}
    }




    print("</td>");
    print("</tr>");
    print("<tr>");
    print("<td valign=\"bottom\" width=\"100%\">");
    // If the user is the owner of the image, then we can print
    // links to alter the thumbnail.
    if ($owner) 
    {
        if ($imagetype=="2-D")
        {

            print("<a href=\"show.php?id=$imageid&try=clockwise&".
	          "imagetype=$imagetype$args\">rotate clockwise</a>");
            print("<br><br>");
            print("<a href=\"show.php?id=$imageid&try=anti-clockwise&".
	          "imagetype=$imagetype$args\">rotate counter clockwise</a>");
	}

    if ($imagetype == "3-D" || $imagetype == "ICS")
        {
            print("<br><br>");                                
            print("<a href=\"show.php?id=$imageid&try=repair_thumbLat&".       
                  "imagetype=$imagetype$args\">remake 3-views thumbnail</a>");
        }  


	if ($imagetype <> "other")
        {
            print("<br><br>");
	    print("<a href=\"show.php?id=$imageid&try=repair_thumb&".
	          "imagetype=$imagetype$args\">remake thumbnail</a>");
        }

	print("<br><br>");
	print("<a href=\"show.php?id=$imageid&try=import_thumb&".
	      "imagetype=$imagetype$args\">import replacement thumbnail</a>");



    }
    // End main cell in main image overview table.
    print("</td>");

    // End old and start new row in the overview table.
    print("</tr><tr>");


   


    // Show the database meta content stored with image.
    print("<td align=\"right\" valign=\"top\">");
    print(display_meta_data(true));
    print("</td>");
    print("<td valign=\"top\">");
   

    // If user is owner of image, give link to modify meta data.
    if ($owner)
    {
	if ($imagetype == "other")
	{
	    print("<a href=\"imagemod.php?imageid=$id&".
		  "imagetype=$imagetype$args\">modify metadata</a>");
	}
	else
	{
	    print("<a href=\"imagemod.php?imageid=$id&".
		  "imagetype=$imagetype$args\">modify image metadata</a>");
	}
    }
    print("</td>");
    // Print end of image overview table.
    print("</tr>");
    print("</table>");
}
// User is not allowed to see requested image.
else
{
    print("<h3>You do not have permission to see this image</h3>");
}


?>
