<?php

  /**************************************************************************\
  * keywords.php    Shows, adds and deletes keywords                         *
  ***************************************************************************
  * Created 7-8-2000 by Nico                                                 *
  * Produces page for keyword management                                     * 
  * Last modified 9-8-2000                                                   *
  *                                                                          *
  * Authors: SVI group University Utrecht and Nico Stuurman                  *
  * email: stuurman@rulbim.leidenuniv.nl                                     *
  * demo at: https://impi.leidenuniv.nl                                      *
  * Last modified 12/17/00                                                   *
  * Copyright (c) 2000 by Nico Stuurman                                      *
  * ------------------------------------------------------------------------ *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/         


$title = "View and manage keywords";

require("include.php");

// register variables
$post_vars = "add,del,new_keyword,delkeys,";
globalize_vars ($post_vars, "HTTP_POST_VARS");

$PHP_SELF = $HTTP_SERVER_VARS["PHP_SELF"];

// show the page
printheader ();

// when called from 'Add new keyword' button
if ($add) {
   if ($S_STATUS < $G_USER) 
      echo "<h3>Sorry, guests may not add keywords</h3><br>\n";
   else 
      if ($new_keyword) make_keyword ($new_keyword);
}


//when called from 'Delete Keyword button
if ($del) {
   if ($S_STATUS < $G_USER) 
      echo "<h3>Sorry, guests may not delete keywords</h3><br>\n";
   else {
      if ($delkeys) {
         db_exec ("BEGIN WORK");
         reset ($delkeys); 
         while (list(, $value) = each ($delkeys)) {
            delete_keyword ($value);
         }
         db_exec ("COMMIT WORK");
      }
   }
}



echo "<FORM ENCTYPE=\"multipart/form-data\" METHOD=\"post\" ACTION=\"$PHP_SELF\">\n";
echo "<TABLE BORDER=0 cellspacing='15'>\n";


//displays available keywords

$the_keys[]=new key_word_id;
$the_keys= get_keyword_group_list();
$nr_keywords= count($the_keys);
$maxsize = 20;

if ($nr_keywords > 0 && $the_keys[0]->keywordid<>0 ) {
   echo "<TR><TD valign='top'><B>Available Keywords</B></TD>\n";
   if ($nr_keywords < $maxsize) 
      $size = $nr_keywords;
   else
      $size = $maxsize;
   echo "<TD><SELECT size=\"$size\" name=\"keys[]\">\n";
   for ($i=0; $i<count($the_keys); $i++) {
      //$temp = new key_word_id;
      $temp=$the_keys[$i];
      $temp->keyword=trim($temp->keyword);
      echo "<OPTION value=\"$temp->keywordid\">$temp->keyword</OPTION>\n";
   }
   echo "</SELECT></TD>";
}
else 
   echo "<TR><TD>No keywords have been entered yet</TD>";


//displays a texbox with Add keyword button

echo "<TR><TD valign='top'><INPUT TYPE=\"submit\" NAME=\"add\" VALUE=\"Add Keyword\"></TD>\n";
echo "<Br><TD valign='top'><INPUT type='TEXT' name='new_keyword'></TD>\n";


//display a multi-select list with currently unused keywords and a button 'delete'

$the_delkeys[]=new key_word_id;
$the_delkeys= get_unused_keywords();
$nr_keywords= count($the_delkeys);

if ($nr_keywords > 0) {
   echo "<TR><TD valign='top'><INPUT TYPE=\"submit\" NAME=\"del\" VALUE=\"Delete Keyword(s)\"></TD>\n";
   if ($nr_keywords < 20) 
      $size = $nr_keywords;
   else
      $size = 20;
   echo "<TD><SELECT multiple size=\"$size\" name=\"delkeys[]\">\n";
   for ($i=0; $i<count($the_delkeys); $i++) {
      $temp = new key_word_id;
      $temp=$the_delkeys[$i];
      $temp->keyword=trim($temp->keyword);
      echo "<OPTION value=\"$temp->keywordid\">$temp->keyword</OPTION>\n";
   }
   echo "</SELECT>";
}


//and finish

echo "</TABLE></FORM>";

printfooter ();

?>
