<?php

  /**************************************************************************\
  * projects.php    Shows, creates and otherwise manages projects            *
  ***************************************************************************
  * When called, produces page with all top-level projects visible to user.  *
  * 'Daughter' projects can be created, and can be reached from the 'Mother' *
  *   project.  Images connected to a project can be displayed. When a       *
  *   chain of projects is broken (because someone else deletes a project or *
  *   makes it invisible, the uppermost project to teh user becomes a        *
  *   project.                                                               * 
  *                                                                          *
  * Author: Nico Stuurman                                                    *
  * email: stuurman@rulbim.leidenuniv.nl                                     *
  * demo at: https://impi.leidenuniv.nl                                      *
  * Copyright (c) 2001 by Nico Stuurman                                      *
  * ------------------------------------------------------------------------ *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/         
$project_fields = "projectid,name,description,userid,rights";

require("include.php");
require ($include_dir."/project_inc.php");

// register variables
$post_vars = "add,del,new_project,submit_project,delkeys,";
$post_vars .= "motherid,projectid,id,edit,delete,create_project";
globalize_vars ($post_vars, "HTTP_POST_VARS");
$get_vars = "id,show";
globalize_vars ($get_vars, "HTTP_GET_VARS");
$PHP_SELF = $HTTP_SERVER_VARS["PHP_SELF"];

$title = "View and manage projects";

// show the page
printheader ();


if ($new_project)
   edit_project (false, false);
elseif ($edit)
   edit_project (false, $id);
elseif ($delete) {
   if ($id = delete_project ($id) )
      show_projects ($id);
   else
      show_projects ($motherid);
}
elseif ($create_project)
   edit_project ($id, false);
elseif ($show)
   show_projects ($id);
elseif ($submit_project) {
   $projectid = upload_project ($motherid, $projectid, $do_modify);
   show_projects ($projectid);
}
else
   show_projects (false);

printfooter ();

?>
