#
# SIDB - web based Scientific Image DataBase application.
#
# Copyright (C) 2000-2003 Nico Stuurman
# Copyright (C) 2003-2004 Frank Keijzers
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# $Id: getParameters.tcl,v 1.3 2005/01/26 08:35:21 jose-v Exp $
#
# This file contains a special Tcl script for use with Huygens to get all
# parameters of 3D images which are uploaded with SIDB.
#


# Just in case... catch the executed code.
if {[catch {

    # Set global undo for Huygens off.
    huOpt gundo off

    # Put all gotten arguments from the argument list into an argument array.
    array set argArray $argv

    # Get all values from arguments.
    set imageValue $argArray(-image)

    # Set opened Huygens image.
    set myImage [img open $imageValue -type byte]
    set pars [$myImage setp -tclReturn]
    set dims [$myImage getdims -mode all]

} result]} {

    puts stderr "ERROR $result"

} else {

    # Output the data.
    puts stdout "OK pars: $pars"
    puts stdout "OK dims: $dims"

}
exit
