<?php

  /**************************************************************************\
  * show.php     displays thumbnail with image meta-data                     *
  ***************************************************************************
  * This script displays a thubmnaisl and the images meta-data.              *
  * It calls show_inc.php to handle most work.                               *
  * Search parameters are passed along with the URL.                         *
  *                                                                          *
  *                                                                          *
  * Authors: SVI group University Utrecht and Nico Stuurman                  *
  * email: nicos@itsa.ucsf.edu                                               *
  * demo at: https://impi.leidenuniv.nl                                      *
  * Last modified 12/17/00 by Nico Stuurman                                  *
  * Copyright (c) 2000, 2001 by Nico Stuurman                                *
  * ------------------------------------------------------------------------ *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/                                                                     

require("include.php");

// register variables
$get_vars = "id,restart,try,imagetype,filetype_extension,";
$get_vars .= "action,number_of_visible_results,file_name,loginname,";
$get_vars .= "file_id,trust,audit,date_day,";
$get_vars .= "date_month,date_year,date_comparison,period,period_nr,";
$get_vars .= "des_cription,restart,trust_array,";
$get_vars .= "keybool,keywrds,serial_selarray,serial_projarray,";
$get_vars .= "namebool,sortby, searchtype, file_x, file_y, file_z";
$get_vars .= "file_thumbx, file_thumby, file_thumbt, file_samplex,";
$get_vars .= "file_sampley, file_samplez, file_samplet, file_NA, file_lri";
$get_vars .= "file_mri, file_numchan, file_inchan, file_ex, file_em,";
$get_vars .= "file_photon, file_ph, microscope, file_color, file_raw";


globalize_vars($get_vars, "HTTP_GET_VARS");

$posted_vars ="try";

globalize_vars($posted_vars, "HTTP_POST_VARS");

$location_thumb = $HTTP_POST_FILES["location_thumb"]["tmp_name"];

// generate string $args to pass all useful values from search.php to 
// other scripts (and receive them back)
$arg_string = "action,number_of_visible_results,loginname,trust,audit,";
$arg_string .= "file_name,file_id,des_cription,audit,restart,";
$arg_string .= "date_comparison,date_day,date_month,date_year,keybool,";
$arg_string .= "period,period_nr,";
$arg_string .= "serial_selarray,projectid,";
$arg_string .= "namebool,sortby, searchtype, file_x, file_y, file_z";
$arg_string .= "file_thumbx, file_thumby, file_thumbt, file_samplex,";
$arg_string .= "file_sampley, file_samplez, file_samplet, file_NA, file_lri";
$arg_string .= "file_mri, file_numchan, file_inchan, file_ex, file_em,";
$arg_string .= "file_photon, file_ph, microscope, file_color, file_raw";



$args = make_args($arg_string);

if ($serial_projarray)
{
    $project_array=unserialize(stripslashes($serial_projarray));
}
if ($trust_array)
{
    $trust=get_array_value($trust_array);
}
if ($audit_array)
{
    $audit=get_array_value($audit_array);
}
if ($serial_projarray)
{
    $args .= "&serial_projarray=" . urlencode(stripslashes($serial_projarray));
}
if ($keywrds)
{
    $keywrds = stripslashes ($keywrds);
    $keywrds = urlencode ($keywrds); 
    $args .= "&"."keywrds=". $keywrds;
}

if ($title="ID $id: " . get_image_info($id,"filename"));
else $title = "The Image";

printheader();

$imageid = $id;

// Check for values of variable $try.
// Make a separate check on importing a thumbnail.
if ($try=="import_thumb")
{
    print("<h3>Please, select the image that you like to appear ".
          "as thumbnail. Note that you will overwrite any existing ".
	  "thumbnails.</h3>\n");  
    print("<form enctype=\"multipart/form-data\" method=\"post\" 
           action=\"show.php?id=$id$args\">\n");
    print("<input type=\"hidden\" name=\"imageid\" value=\"$imageid\">\n");
    print("<table border=0>\n");
    print("<tr>");
    print("<td>Thumbnail location</td>");
    print("<td>");
    print("<input type=\"file\" name=\"location_thumb\" ".
          "value=\"$location_thumb\">");
    print("</td>\n");
    print("</tr>");
    print("<tr>");
    print("<td align=\"right\">");
    print("<input type=\"submit\" name=\"try\" ".
          "value=\"Import Thumbnail\">");
    print("</td>\n");
    print("<td></td>");
    print("</tr>\n");
    print("</table>\n");
    print("</form>\n");
}
// For rest of values, check for apropiate function to call.
else
{
    if ($try == "Import Thumbnail")
    {
	import_thumbnail($location_thumb,$imageid);
    }
    elseif ($try == "repair_thumb")
    {
	if ($imagetype=="2-D")
	{
	    // set rotation to 0
	    $image_settings["rotation"] = 0;
	    set_image_settings($imageid, $image_settings);
	    other_thumbnail($location_name, $imageid);
	}
	elseif ($imagetype =="multipage")
	{
	    other_thumbnail($location_name, $imageid);
	}
	elseif ($imagetype =="3-D" || $imagetype=="ICS")
	{
	    huygens_thumbnail($array["filename"], $imageid);
	}
	elseif ($imagetype =="other")
	{
	    print("<h3>Can not remake thumbnail. ".
		  "Try to import thumbnail instead.</h3>");
	}
    }
    elseif ($try == "repair_thumbLat")
    {
         huygens_thumbnail($array["filename"], $imageid,true);
    }
    elseif ($try == "anti-clockwise")
    {
        if ($imagetype=="2-D")
	{
            $image_settings = get_image_settings($imageid);
            $image_settings["rotation"] -= 90;
            $rotation = $image_settings["rotation"];
            set_image_settings($id, $image_settings);
            other_thumbnail($location_name, $imageid, "-rotate $rotation");
        }
    }
    elseif ($try == "clockwise")
    {
        if ($imagetype == "2-D")
	{
            $image_settings = get_image_settings($imageid);
            $image_settings["rotation"] += 90;
            $rotation = $image_settings["rotation"];
            set_image_settings($id, $image_settings);
            other_thumbnail($location_name, $imageid, "-rotate $rotation");
        }
    }
    elseif ($try == "save_ics")
    {
        require ("$include_dir/export_inc.php");
        save_as_ics($imageid);
    }
    elseif ($try == "rotate_3D" && $make_rotating_movie)
    {
        huygens_rotate($id, 20, 180, "x");
    }

    // Include the file that does all the printing work for
    // the overview page of the image.
    include ("$include_dir/show_inc.php");
   
    // Do special check on use of ImageJ.
    if ($try=="imagej")
    {
        print("\n<applet code=\"IJApplet.class\" archive=\"ij.jar\">");
        // This is the way Imagej wants the extension of Tiff file.
        if ($filetype_extension == "TIFF")
	{
            $filetype_extension = ".tif";
	}
        print("<param name=\"image\" value=\"download.php?imageid=$imageid".
	      "&imagetype=$imagetype&imagej=$filetype_extension\">\n");
        print("</applet>\n");
    }
}

printfooter();
?>
