<?php

// templates.php -  Create, modify, and delete templates
// emplates.php - author: SVI group University Utrecht and Nico Stuurman
  /***************************************************************************
  * The script displays a table with existing templates owned by the user.   *
  * Functions to add, modify and delete templates  are integrated.           *
  *                                                                          *
  *                                                                          *
  * Authors: SVI group University Utrecht and Nico Stuurman                  *
  * email: nicos@sidb.sourceforge.net                                        *
  * demo at: https://impi.leidenuniv.nl                                      *
  * Copyright (c) 2000, 2001 by Nico Stuurman                                *
  * ------------------------------------------------------------------------ *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/                                          


require("include.php");
include ("$include_dir/template_inc.php");

// register variables
$post_vars = "new,add,new_modify,channel_up,templatename,mod,templateid,";
$post_vars .= "filetype,uploadtype,modify,";
$post_vars .= "mime,resubmit,description,x_thumb,y_thumb,fs_thumb,";
$post_vars .= "raw_data,keys,viewrights,trust_array,";
$post_vars .= "x_nm,y_nm,z_nm,t_sec,scope,fs,projects,refrinxlensmedium,";
$post_vars .= "numaperture,refrinxmedium,nr_channels,channel_up,";
$post_vars .= "exp_never_box,exp_unit,exp_number,";

globalize_vars ($post_vars,"HTTP_POST_VARS");

$PHP_SELF = $HTTP_SERVER_VARS["PHP_SELF"];



$title="View and manage templates"; 

printheader("javascript/template.js");

// First check whether modify or delete button has been chosen
if ($HTTP_POST_VARS) {
   //determine wether or not the remove-command is given and act on it
   while((list($key, $val) = each($HTTP_POST_VARS))) {
      if (substr($key, 0, 3) == "del") {
         $delarray = explode("_", $key);
         $del = true; 
      }
      if (substr($key, 0, 3) == "mop") {
         $modarray = explode ("_", $key);
         $mod = true;
      } 
   }
}  

// check whether the script has been called from within
if ($new=="new template") {
   show_template_form ($filetype, "html", "new");
}

// working on a new template
elseif ($new_modify=="new"  &&
        ($channel_up || $channel_down || exist($templatename) || $templatename=="") ) {
   // when a new template has been entered whose name had been chosen already
   if (exist ($templatename))  {
      echo "You have used this templatename before.  Please choose another one<br>";
      show_template_form ($filetype, "html", "new");
   }
   // when a new template has been entered without a name
   elseif ($templatename=="") {
      echo "<h1>Please enter a templatename<br></h1>";
      show_template_form ($filetype, "html", "new");
   }
   elseif ($channel_up || $channel_down)
      show_template_form ($filetype, "html", "new");
}

// modifying a template
// when modify button has been chosen in table
elseif ($mod) {
   modify_template($modarray[1]);
}

// working on the modification of a template
elseif ($new_modify=="modify" &&
         ($channel_up || $channel_down  ||
         ( (exist($templatename)) && ($templateid != exist($templatename) ) ) ||
         $templatename == "" )  ) {
   modify_template($templateid);
}


// the following calls from within finalize transactions and need to display the table afterwards
else {
   // when a new template has been entered:
   if ($add=="Add template") {
      $query = make_template_query();
      make_the_template ($query, $templatename, $keys);
   }
   
   // when a template has been modifed
   elseif ($modify) {
      modify_template ($templateid);
   }
   // when delete button has been chosen
   elseif ($del == true) {
      echo (delete_template($delarray[1]));
   }  

   // display existing templates and new template button 
   $db_query = "SELECT * FROM template WHERE userid='$S_USERID' ORDER BY templatename;";
   $db_result = do_database_query($db_query);
   $db_rows = db_numrows ($db_result);

   // print header of table
   echo "<table border=\"1\">\n";
   echo "<tr>\n";
   echo "<th>Template Name</th>\n";
   echo "<th>Type</th>\n";
   echo "<th colspan=\"2\">Action</th>\n";
   echo "</tr>\n";

   // form is needed for delete command
   echo "<form name='form' method='post' action='$PHP_SELF'>\n";        

   // for each row, print result in table cells
   for ($i=0; $i<$db_rows; $i++) {
      // set database result per row
      $db_row_result = db_fetch_array($db_result, $i);
      $type = get_template_info ($db_row_result["templateid"], "filetype");
      if (!$type)
         $type = "&nbsp ";
 
      // print table output per row
      echo "<tr>\n";
      echo "<td><b>".$db_row_result["templatename"]."</b></td>\n";
      echo "<td>$type</td>\n";

      $modstring = "<input type=\"submit\" name=\"mop_" . $db_row_result["templateid"] . "\" value=\"Modify\" >";
      echo "<td align=\"center\">$modstring</td>\n";                                                             
      
      $delstring = "<input type=\"submit\" name=\"del_" . $db_row_result["templateid"] . "\" value=\"Remove\" ";
      $delstring .= "Onclick=\"if(confirm('Do you really want to delete the template ";
      $delstring .= $db_row_result["templatename"] . "?')){return true;}return false;\">";
      echo "<td align=\"center\">$delstring</td></tr>\n";                                                             
      echo "</tr>\n";
   }

   // print end of table    
   echo "</form>\n";
   echo "</table>\n";

   //print add new template button
   echo "<FORM enctype='multipart/form-data' METHOD='post' ACTION='$PHP_SELF'>\n";
   echo "<INPUT TYPE='submit' NAME='new' VALUE='new template'></INPUT>\n";
   // add a type selection box
   echo "of type: ";
   box_type();

   echo "</FORM>\n";

}


// in all cases:
closedatabase();
printfooter();
?>
